unit FrmResMet;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TFormResourceStats = class(TForm)
    Timer1: TTimer;
    LabelMemoryLoad: TLabel;
    LabelTotalPhys: TLabel;
    LabelAvailPhys: TLabel;
    LabelTotalPageFile: TLabel;
    LabelAvailPageFile: TLabel;
    LabelTotalVirtual: TLabel;
    LabelAvailVirtual: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    LabelAvailPhysChange: TLabel;
    LabelAvailPageFileChange: TLabel;
    LabelAvailVirtualChange: TLabel;
    LabelLostPhys: TLabel;
    LabelLostPageFile: TLabel;
    LabelLostVirtual: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    SpeedButton1: TSpeedButton;
    Bevel5: TBevel;
    Bevel6: TBevel;
    Bevel7: TBevel;
    Bevel8: TBevel;
    Bevel9: TBevel;
    Bevel10: TBevel;
    Bevel11: TBevel;
    SpeedButton2: TSpeedButton;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    FFirst             : Boolean;
    FLastAvailPhys     : DWORD;
    FLastAvailPageFile : DWORD;
    FLastAvailVirtual  : DWORD;
    FStartPhys         : DWORD;
    FStartPageFile     : DWORD;
    FStartVirtual      : DWORD;
  public
    { Public declarations }
  end;

var
  FormResourceStats: TFormResourceStats;

implementation


{$R *.DFM}

     Function PosFmt( i : Integer): String;
     Begin
       If i < 1000
       Then Result := Format( '%d', [ i])
       Else Result := PosFmt( i Div 1000)  + '.' + Format( '%.3d', [ i Mod 1000])
     End;

     Function IntToStrFmt( i : Integer): String;
     Begin
       If i < 0
       Then Result := '-' + PosFmt( - i)
       Else Result := '+' + PosFmt(   i);
     End;

{
  Delphi area
}

procedure TFormResourceStats.Timer1Timer(Sender: TObject);
var
  MemoryStatus: TMemoryStatus;
begin
  MemoryStatus.dwLength := SizeOf( MemoryStatus);
  GlobalMemoryStatus( MemoryStatus);
  With MemoryStatus Do
  Begin
    LabelMemoryLoad   .Caption := IntToStrFmt( dwMemoryLoad);

    LabelTotalPhys    .Caption := IntToStrFmt( dwTotalPhys);
    LabelAvailPhys    .Caption := IntToStrFmt( dwAvailPhys);

    LabelTotalPageFile.Caption := IntToStrFmt( dwTotalPageFile);
    LabelAvailPageFile.Caption := IntToStrFmt( dwAvailPageFile);

    LabelTotalVirtual .Caption := IntToStrFmt( dwTotalVirtual);
    LabelAvailVirtual .Caption := IntToStrFmt( dwAvailVirtual);

    If FFirst
    Then Begin
      FFirst := False;
      FStartPhys     := dwAvailPhys;
      FStartPageFile := dwAvailPageFile;
      FStartVirtual  := dwAvailVirtual;
      LabelAvailPhysChange    .Caption := '-';
      LabelAvailPageFileChange.Caption := '-';
      LabelAvailVirtualChange .Caption := '-';
    End
    Else Begin
      If FLastAvailPhys <> dwAvailPhys
      Then LabelAvailPhysChange.Caption := IntToStrFmt( Integer( FLastAvailPhys) - Integer( dwAvailPhys));
      If FLastAvailPageFile <> dwAvailPageFile
      Then LabelAvailPageFileChange.Caption := IntToStrFmt( Integer( FLastAvailPageFile) - Integer( dwAvailPageFile));
      If FLastAvailVirtual <> dwAvailVirtual
      Then LabelAvailVirtualChange.Caption := IntToStrFmt( Integer( FLastAvailVirtual) - Integer( dwAvailVirtual));
    End;

    LabelLostPhys     .Caption := IntToStrFmt( Integer( FStartPhys    ) - Integer( dwAvailPhys    ));
    LabelLostPageFile .Caption := IntToStrFmt( Integer( FStartPageFile) - Integer( dwAvailPageFile));
    LabelLostVirtual  .Caption := IntToStrFmt( Integer( FStartVirtual ) - Integer( dwAvailVirtual ));

    FLastAvailPhys     := dwAvailPhys;
    FLastAvailPageFile := dwAvailPageFile;
    FLastAvailVirtual  := dwAvailVirtual;
  End;
end;

procedure TFormResourceStats.FormCreate(Sender: TObject);
begin
  FFirst := True;
end;

procedure TFormResourceStats.SpeedButton1Click(Sender: TObject);
begin
  Close;
end;

procedure TFormResourceStats.SpeedButton2Click(Sender: TObject);
begin
  FFirst := True;
end;

end.

