program MidiMod;

{
  BLUE HELL software.

  Copyright (C) 1999 .. 2012, Jan Punter.

  Notes :

    midi componenets needed : http://sourceforge.net/projects/dmidi/
    hires timer needed      : source code included ... I may have stolen that somewhere without
                              acknowleging the source .. somewhere in 1999 or so ...
                              It sure looks a lot like : http://www.programmersheaven.com/download/2818/1/ZipView.aspx
                              but details as to the origin seem absent there too.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

}

uses
  Windows,
  SysUtils,
  Classes,
  Forms,
  FrmMain in 'FrmMain.pas' {FormMain},
  FrmMidDlg in 'FrmMidDlg.pas' {FormMidiDialog},
  FrmAbout in 'FrmAbout.pas' {FormAbout},
  FrmRndSet in 'FrmRndSet.pas' {FormRandomSettings},
  Modules in 'Modules.pas',
  MoreMods in 'MoreMods.pas',
  Globals in 'Globals.pas',
  FrmColor in 'FrmColor.pas' {Form1};

{$R *.RES}

Var

  CommandLine : Atom;
  aData       : Array[ 0 .. 1024] Of Char;

begin

  // Check to see if a previous instance is running,
  // if so post it this instance's commandline
  // so that the previous instance can :
  // - pop itself up.
  // - possibly open a new slot window.

{$WARN UNSAFE_CODE OFF}

  CreateMutex( Nil, False, 'MidiMod7_AppEntry');
  If GetLastError = ERROR_ALREADY_EXISTS
  Then Begin
    If ParamCount >= 1
    Then Begin
      StrPCopy( @ aData, ParamStr( 1));
      CommandLine := GlobalAddAtom( aData)
    End
    Else CommandLine := 0;
    Try
      SendMessage(
        HWND_BROADCAST,
        RegisterWindowMessage( 'MidiMod7_CommandLine'),
        LongInt( CommandLine),
        0
      );
    Finally
      Halt( 0);
    End;
  End;

  // Back to the normal Delphi startup stuff

  Application.Initialize;

  // Some more special stuff ..

  Application.ShowMainForm := True;
  ShowWindow( Application.Handle, SW_RESTORE);

  // And back to normal again.

  Application.CreateForm(TFormMain, FormMain);
  Application.CreateForm(TFormMidiDialog, FormMidiDialog);
  Application.CreateForm(TFormAbout, FormAbout);
  Application.CreateForm(TFormRandomSettings, FormRandomSettings);
  Application.CreateForm(TForm1, Form1);
  Application.Run;
end.
