Unit MoreMods;

{
  BLUE HELL software.

  Copyright (C) 1999 .. 2012, Jan Punter.

  Notes :

    midi componenets needed : http://sourceforge.net/projects/dmidi/
    hires timer needed      : source code included ... I may have stolen that somewhere without
                              acknowleging the source .. somewhere in 1999 or so ...
                              It sure looks a lot like : http://www.programmersheaven.com/download/2818/1/ZipView.aspx
                              but details as to the origin seem absent there too.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

}

Interface

Uses

  Windows, Modules, Graphics, SysUtils, Classes, Math, Globals;

Type

  TMimConstant = Class( TMimCustomModule)
  Private
      FKnobAmp : TMimKnob;
      FOut     : TMimOutput;
    Procedure   KnobAmpValChanged ( aSender: TObject; aValue: TMimValue);
    Function    GetKnobAmpValue : TMimValue;
    Procedure   SetKnobAmpValue ( aValue: TMimValue);
  Protected
    Procedure   CreateDetails;                                         Override;
  Published
    Property    KnobAmpValue  : TMimValue Read GetKnobAmpValue  Write SetKnobAmpValue;
  End;


  TMimAmplifier = Class( TMimCustomModule)
  Private
      FKnobAmp   : TMimKnob;
      FKnobClip  : TMimKnob;
      FIn        : TMimInput;
      FInClip    : TMimInput;
      FOut       : TMimOutput;
      FAmplitude : TMimValue;
      FClipLevel : TMimValue;
    Procedure   KnobAmpValChanged ( aSender: TObject; aValue: TMimValue);
    Procedure   KnobClipValChanged( aSender: TObject; aValue: TMimValue);
    Function    GetKnobAmpValue : TMimValue;
    Procedure   SetKnobAmpValue ( aValue: TMimValue);
    Function    GetKnobClipValue : TMimValue;
    Procedure   SetKnobClipValue ( aValue: TMimValue);
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   Execute;                                               Override;
  Published
    Property    KnobAmpValue  : TMimValue Read GetKnobAmpValue  Write SetKnobAmpValue;
    Property    KnobClipValue : TMimValue Read GetKnobClipValue Write SetKnobClipValue;
  End;

  TMimMultiplier = Class( TMimCustomModule)
  Private
      FKnobAmp   : TMimKnob;
      FIn1       : TMimInput;
      FIn2       : TMimInput;
      FOut       : TMimOutput;
      FInLabel   : TMimTextLabel;
      FAmplitude : TMimValue;
    Procedure   KnobAmpValChanged ( aSender: TObject; aValue: TMimValue);
    Function    GetKnobAmpValue : TMimValue;
    Procedure   SetKnobAmpValue ( aValue: TMimValue);
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   Execute;                                               Override;
  Published
    Property    KnobAmpValue  : TMimValue Read GetKnobAmpValue  Write SetKnobAmpValue;
  End;


  TMimDivider = Class( TMimMultiplier)
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   Execute;                                               Override;
  End;


  TMimOscillator = Class( TMimCustomModule)
  Private
      FKnobFreq  : TMimKnob;
      FIndicator : TMimLed;
      FKnobAmp   : TMimKnob;
      FButton    : TMimPushButton;
      FButSym    : TMimPushButton;
      FButRng    : TMimPushButton;
      FOut       : TMimOutput;
      FSync      : TMimInput;
      FInFmMod   : TMimInput;
      FInAmMod   : TMimInput;
      FLabelSync : TMimTextLabel;
      FActive    : Boolean;
      FSymetric  : Boolean;
      FCounter   : Integer;
      FTime      : TMimValue;
      FLimit     : TMimValue;
      FAmplitude : TMimValue;
      FampMax    : TMimValue;
      FPrevSync  : TMimValue;
      FRange     : Integer;
      FDisplay   : TMimTextLabel;
    Procedure   KnobFreqValChanged( aSender: TObject; aValue: TMimValue); Virtual;
    Procedure   KnobAmpValChanged ( aSender: TObject; aValue: TMimValue);
    Procedure   ButtonValueChanged( aSender: TObject; aValue: Boolean);
    Procedure   ButSymValueChanged( aSender: TObject; aValue: Boolean);
    Procedure   ButRngClicked( aSender: TObject);
    Function    GetKnobFreqValue: TMimValue;
    Procedure   SetKnobFreqValue( aValue: TMimValue);
    Function    GetKnobAmpValue : TMimValue;
    Procedure   SetKnobAmpValue ( aValue: TMimValue);
    Function    GetButtonDown: Boolean;
    Procedure   SetButtonDown( aValue: Boolean);
    Function    GetButSymDown: Boolean;
    Procedure   SetButSymDown( aValue: Boolean);
    Procedure   SetRange( aValue: Integer);                            Virtual;
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   Execute;                                               Override;
    Procedure   PerformExec;                                           Virtual;
  Published
    Property    Range         : Integer Read FRange           Write SetRange;
    Property    KnobFreqValue : TMimValue  Read GetKnobFreqValue Write SetKnobFreqValue;
    Property    KnobAmpValue  : TMimValue  Read GetKnobAmpValue  Write SetKnobAmpValue;
    Property    ButtonDown    : Boolean Read GetButtonDown    Write SetButtonDown;
    Property    ButSymDown    : Boolean Read GetButSymDown    Write SetButSymDown;
  End;

  TMimSquare = Class( TMimOscillator)
  Private
      FInPwMod    : TMimInput;
      FKnobWidth  : TMimKnob;
      FPulseWidth : TMimValue;
    Procedure   KnobWidthChanged( aSender: TObject; aValue: TMimValue);
    Function    GetKnobWidthValue: TMimValue;
    Procedure   SetKnobWidthValue( aValue: TMimValue);
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   PerformExec;                                           Override;
  Published
    Property    KnobWidthValue : TMimValue Read GetKnobWidthValue Write SetKnobWidthValue;
  End;


  TMimSine = Class( TMimOscillator)
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   PerformExec;                                           Override;
  End;


  TMimSaw = Class( TMimOscillator)
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   PerformExec;                                           Override;
  End;


  TMimRandom = Class( TMimOscillator)
  Private
      FInColorMod : TMimInput;
      FKnobColor  : TMimKnob;
      FRndColor   : TMimValue;
    Procedure   KnobColorChanged( aSender: TObject; aValue: TMimValue);
    Function    GetKnobColorValue: TMimValue;
    Procedure   SetKnobColorValue( aValue: TMimValue);
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   PerformExec;                                           Override;
  Published
    Property    KnobColor : TMimValue Read GetKnobColorValue Write SetKnobColorValue;
  End;


  TMimRndPulse = Class( TMimOscillator)
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   PerformExec;                                           Override;
  End;


  TMimClockedOscillator = Class( TMimOscillator)
  Private
    Procedure   KnobFreqValChanged( aSender: TObject; aValue: TMimValue); Override;
    Procedure   SetRange( aValue: Integer);                            Override;
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   Execute;                                               Override;
  End;

  TMimClSquare = Class( TMimClockedOscillator)
  Private
      FInPwMod    : TMimInput;
      FKnobWidth  : TMimKnob;
      FPulseWidth : TMimValue;
    Procedure   KnobWidthChanged( aSender: TObject; aValue: TMimValue);
    Function    GetKnobWidthValue: TMimValue;
    Procedure   SetKnobWidthValue( aValue: TMimValue);
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   PerformExec;                                           Override;
  Published
    Property    KnobWidthValue : TMimValue Read GetKnobWidthValue Write SetKnobWidthValue;
  End;


  TMimClSine = Class( TMimClockedOscillator)
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   PerformExec;                                           Override;
  End;


  TMimClSaw = Class( TMimClockedOscillator)
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   PerformExec;                                           Override;
  End;


  TMimClRandom = Class( TMimClockedOscillator)
  Private
      FInColorMod : TMimInput;
      FKnobColor  : TMimKnob;
      FRndColor   : TMimValue;
    Procedure   KnobColorChanged( aSender: TObject; aValue: TMimValue);
    Function    GetKnobColorValue: TMimValue;
    Procedure   SetKnobColorValue( aValue: TMimValue);
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   PerformExec;                                           Override;
  Published
    Property    KnobColor : TMimValue Read GetKnobColorValue Write SetKnobColorValue;
  End;


  TMimClRndPulse = Class( TMimClockedOscillator)
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   PerformExec;                                           Override;
  End;


  TMimMidiIn = Class( TMimMidiModule)
  Private
      FOutNote   : TMimOutput;
      FOutGate   : TMimOutput;
      FOutVel    : TMimOutput;
      FOutVelOff : TMimOutput;
      FIndicator : TMimLed;
      FKnobCh    : TMimKnob;
      FChannel   : Integer;
    Procedure   KnobChValueChanged( aSender: TObject; aValue: TMimValue);
    Function    GetKnobChValue: TMimValue;
    Procedure   SetKnobChValue( aValue: TMimValue);
  Protected
    Procedure   CreateDetails;                                         Override;
    Procedure   AcceptMidiShort( aShortMidi: TShortMidi);              Override;
  Published
    Property    KnobChValue : TMimValue Read GetKnobChValue Write SetKnobChValue;
  End;


  TMimMidiOut = Class( TMimMidiModule)
  Private
      FInNote     : TMimInput;
      FInGate     : TMimInput;
      FInVel      : TMimInput;
      FInVelOff   : TMimInput;
      FInCh       : TMimInput;
      FIndicator  : TMimLed;
      FKnobCh     : TMimKnob;
      FButtonGate : TMimPushButton;
      FChannel    : Integer;
      FOldNote    : Integer;
      FOldGate    : Integer;
      FPrevChVal  : Integer;
      FGateActive : Boolean;
    Procedure   KnobChValueChanged( aSender: TObject; aValue: TMimValue);
    Procedure   ButtonGateChanged ( aSender: TObject; aValue: Boolean);
    Function    GetKnobChValue: TMimValue;
    Procedure   SetKnobChValue( aValue: TMimValue);
    Function    GetButtonGateDown: Boolean;
    Procedure   SetButtonGateDown( aValue: Boolean);
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   Execute;                                               Override;
  Published
    Property    KnobChValue    : TMimValue  Read GetKnobChValue    Write SetKnobChValue;
    Property    ButtonGateDown : Boolean Read GetButtonGateDown Write SetButtonGateDown;
  End;


  TMimControlIn = Class( TMimMidiModule)
  Private
      FOut     : TMimOutput;
      FKnobCh  : TMimKnob;
      FKnobCtr : TMimKnob;
      FInd     : TMimLed;
      FCh      : Integer;
      FCtr     : Integer;
    procedure   KnobChValueChanged ( aSender: TObject; aValue: TMimValue);
    Procedure   KnobCtrValueChanged( aSender: TObject; aValue: TMimValue);
    Function    GetKnobChValue : TMimValue;
    Procedure   SetKnobChValue ( aValue: TMimValue);
    Function    GetKnobCtrValue: TMimValue;
    Procedure   SetKnobCtrValue( aValue: TMimValue);
  Protected
    Procedure   CreateDetails;                                         Override;
    Procedure   AcceptMidiShort( aShortMidi: TShortMidi);              Override;
  Published
    Property    KnobChValue  : TMimValue Read GetKnobChValue  Write SetKnobChValue;
    Property    KnobCtrValue : TMimValue Read GetKnobCtrValue Write SetKnobCtrValue;
  End;

  TMimControlOut = Class( TMimMidiModule)
  Private
      FIn        : TMimInput;
      FInCh      : TMimInput;
      FInCtr     : TMimInput;
      FKnobCh    : TMimKnob;
      FKnobCtr   : TMimKnob;
      FChannel   : Integer;
      FCtr       : Integer;
      FPrevValue : Integer;
      FPrevChVal : Integer;
      FPrevCtrVal: Integer;
    procedure   KnobChValueChanged ( aSender: TObject; aValue: TMimValue);
    Procedure   KnobCtrValueChanged( aSender: TObject; aValue: TMimValue);
    Function    GetKnobChValue : TMimValue;
    Procedure   SetKnobChValue ( aValue: TMimValue);
    Function    GetKnobCtrValue: TMimValue;
    Procedure   SetKnobCtrValue( aValue: TMimValue);
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   Execute;                                               Override;
  Published
    Property    KnobChValue  : TMimValue Read GetKnobChValue  Write SetKnobChValue;
    Property    KnobCtrValue : TMimValue Read GetKnobCtrValue Write SetKnobCtrValue;
  End;


  TMimBendIn = Class( TMimMidiModule)
  Private
      FOut       : TMimOutput;
      FKnobCh    : TMimKnob;
      FKnobSense : TMimKnob;
      FInd       : TMimLed;
      FCh        : Integer;
      FSense     : TMimValue;
      FIndCount  : Integer;
    procedure   KnobChValueChanged   ( aSender: TObject; aValue: TMimValue);
    Procedure   KnobSenseValueChanged( aSender: TObject; aValue: TMimValue);
    Function    GetKnobChValue   : TMimValue;
    Procedure   SetKnobChValue   ( aValue: TMimValue);
    Function    GetKnobSenseValue: TMimValue;
    Procedure   SetKnobSenseValue( aValue: TMimValue);
  Protected
    Procedure   CreateDetails;                                         Override;
    Procedure   AcceptMidiShort( aShortMidi: TShortMidi);              Override;
  Published
    Property    KnobChValue    : TMimValue Read GetKnobChValue    Write SetKnobChValue;
    Property    KnobSenseValue : TMimValue Read GetKnobSenseValue Write SetKnobSenseValue;
  End;

  TMimBendOut = Class( TMimMidiModule)
  Private
      FIn           : TMimInput;
      FInCh         : TMimInput;
      FInSense      : TMimInput;
      FKnobCh       : TMimKnob;
      FKnobSense    : TMimKnob;
      FChannel      : Integer;
      FSense        : TMimValue;
      FPrevValue    : Integer;
      FPrevChVal    : Integer;
      FPrevSenseVal : Integer;
    procedure   KnobChValueChanged   ( aSender: TObject; aValue: TMimValue);
    Procedure   KnobSenseValueChanged( aSender: TObject; aValue: TMimValue);
    Function    GetKnobChValue   : TMimValue;
    Procedure   SetKnobChValue   ( aValue: TMimValue);
    Function    GetKnobSenseValue: TMimValue;
    Procedure   SetKnobSenseValue( aValue: TMimValue);
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   Execute;                                               Override;
  Published
    Property    KnobChValue    : TMimValue Read GetKnobChValue    Write SetKnobChValue;
    Property    KnobSenseValue : TMimValue Read GetKnobSenseValue Write SetKnobSenseValue;
  End;


  TMimDividerFixed = Class( TMimCustomModule)
  Private
      FIn        : TMimInput;
      FOut1      : TMimOutput;
      FOut2      : TMimOutput;
      FOut4      : TMimOutput;
      FOut8      : TMimOutput;
      FOut16     : TMimOutput;
      FOut32     : TMimOutput;
      FOut64     : TMimOutput;
      FOut128    : TMimOutput;
      FOut256    : TMimOutput;
      FOut512    : TMimOutput;
      FOut1024   : TMimOutput;
      FInd1      : TMimLed;
      FInd2      : TMimLed;
      FInd4      : TMimLed;
      Find8      : TMimLed;
      FInd16     : TMimLed;
      FInd32     : TMimLed;
      FInd64     : TMimLed;
      FInd128    : TMimLed;
      FInd256    : TMimLed;
      FInd512    : TMimLed;
      FInd1024   : TMimLed;
      FCounter   : Integer;
      FPrevValue : TMimValue;
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   Execute;                                               Override;
  End;


  TMimFreqDivider = Class( TMimCustomModule)
  Private
      FInp       : TMimInput;
      FSync      : TMimInput;
      FOutp      : TMimOutput;
      FKnob      : TMimKnob;
      FIndicator : TMimLed;
      FDivisor   : Integer;
      FCounter   : Integer;
      FPrevValue : TMimValue;
      FPrevSync  : TMimValue;
    Procedure   KnobValueChanged( aSender: TObject; aValue: TMimValue);
    Function    GetKnobValue: TMimValue;
    Procedure   SetKnobValue( aValue: TMimValue);
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   Execute;                                               Override;
  Published
    Property    KnobValue: TMimValue Read GetKnobValue Write SetKnobValue;
  End;


  TMimTable = Class( TMimCustomModule)
  Private
      FK1       : TMimKnob;
      FK2       : TMimKnob;
      FK3       : TMimKnob;
      FK4       : TMimKnob;
      FK5       : TMimKnob;
      FK6       : TMimKnob;
      FK7       : TMimKnob;
      FK8       : TMimKnob;
      FI1       : TMimLed;
      FI2       : TMimLed;
      FI3       : TMimLed;
      FI4       : TMimLed;
      FI5       : TMimLed;
      FI6       : TMimLed;
      FI7       : TMimLed;
      FI8       : TMimLed;
      FInp      : TMimInput;
      Foutp     : TMimOutput;
      FChain    : TMimOutput;
      FSV       : TMimKnob;
      FButMode  : TMimPushButton;
      FValues   : Array[ 1 .. 8] Of TMimValue;
      FStartVal : TMimValue;
      FViewMode : Integer;
    Procedure   KValueChanged  ( aSender: TObject; aValue: TMimValue);
    Procedure   StartValChanged( aSender: TObject; aValue: TMimValue);
    Procedure   ButModeValueChanged( aSender: TObject; aValue: Boolean);
    Procedure   SetKValue( aK: TMimKnob; aValue: TMimValue);
    Procedure   SetK1 ( aValue: TMimValue);
    Procedure   SetK2 ( aValue: TMimValue);
    Procedure   SetK3 ( aValue: TMimValue);
    Procedure   SetK4 ( aValue: TMimValue);
    Procedure   SetK5 ( aValue: TMimValue);
    Procedure   SetK6 ( aValue: TMimValue);
    Procedure   SetK7 ( aValue: TMimValue);
    Procedure   SetK8 ( aValue: TMimValue);
    Procedure   SetSV ( aValue: TMimValue);
    Function    GetK1 : TMimValue;
    Function    GetK2 : TMimValue;
    Function    GetK3 : TMimValue;
    Function    GetK4 : TMimValue;
    Function    GetK5 : TMimValue;
    Function    GetK6 : TMimValue;
    Function    GetK7 : TMimValue;
    Function    GetK8 : TMimValue;
    Function    GetSV : TMimValue;
    Function    GetButModeDown: Boolean;
    Procedure   SetButModeDown( aValue: Boolean);
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   Execute;                                               Override;
  Published
    Property    K1          : TMimValue Read GetK1           Write SetK1;
    Property    K2          : TMimValue Read GetK2           Write SetK2;
    Property    K3          : TMimValue Read GetK3           Write SetK3;
    Property    K4          : TMimValue Read GetK4           Write SetK4;
    Property    K5          : TMimValue Read GetK5           Write SetK5;
    Property    K6          : TMimValue Read GetK6           Write SetK6;
    Property    K7          : TMimValue Read GetK7           Write SetK7;
    Property    K8          : TMimValue Read GetK8           Write SetK8;
    Property    SV          : TMimValue Read GetSV           Write SetSV;
    Property    ButModeDown : Boolean Read GetButModeDown Write SetButModeDown;
  End;


  TMimNeuron = Class( TMimCustomModule)
  Private
      FOut       : TMimOutput;
      FOutLearn  : TMimOutput;
      FIn1       : TMimInput;
      FIn2       : TMimInput;
      FIn3       : TMimInput;
      FIn4       : TMimInput;
      FIn5       : TMimInput;
      FIn6       : TMimInput;
      FIn7       : TMimInput;
      FIn8       : TMimInput;
      FIn9       : TMimInput;
      FIn10      : TMimInput;
      FInLearn   : TMimInput;
      FInd1      : TMimLed;
      FInd2      : TMimLed;
      FInd3      : TMimLed;
      Find4      : TMimLed;
      FInd5      : TMimLed;
      FInd6      : TMimLed;
      FInd7      : TMimLed;
      FInd8      : TMimLed;
      FInd9      : TMimLed;
      FInd10     : TMimLed;
      FIndLearn  : TMimLed;
      FIndOut    : TMimLed;
      FK1        : TMimKnob;
      FK2        : TMimKnob;
      FK3        : TMimKnob;
      FK4        : TMimKnob;
      FK5        : TMimKnob;
      FK6        : TMimKnob;
      FK7        : TMimKnob;
      FK8        : TMimKnob;
      FK9        : TMimKnob;
      FK10       : TMimKnob;
      FKnobParam : TMimKnob;
      FButtonAlg : TMimPushButton;
      FLabelAlg  : TMimTextLabel;
      FWeights   : Array[ 1 .. 10] Of TMimValue;
      FOldLearn  : TMimValue;
      FAlgorithm : Integer;
      FParam     : TMimValue;
    Procedure   KValueChanged( aSender: TObject; aValue: TMimValue);
    Procedure   KnobParamChanged( aSender: TObject; aValue: TMimValue);
    Procedure   ButtonAlgClicked( aSender: TObject);
    Function    GetK1 : TMimValue;
    Procedure   SetK1 ( aValue: TMimValue);
    Function    GetK2 : TMimValue;
    Procedure   SetK2 ( aValue: TMimValue);
    Function    GetK3 : TMimValue;
    Procedure   SetK3 ( aValue: TMimValue);
    Function    GetK4 : TMimValue;
    Procedure   SetK4 ( aValue: TMimValue);
    Function    GetK5 : TMimValue;
    Procedure   SetK5 ( aValue: TMimValue);
    Function    GetK6 : TMimValue;
    Procedure   SetK6 ( aValue: TMimValue);
    Function    GetK7 : TMimValue;
    Procedure   SetK7 ( aValue: TMimValue);
    Function    GetK8 : TMimValue;
    Procedure   SetK8 ( aValue: TMimValue);
    Function    GetK9 : TMimValue;
    Procedure   SetK9 ( aValue: TMimValue);
    Function    GetK10: TMimValue;
    Procedure   SetK10( aValue: TMimValue);
    Procedure   SetAlgorithm( aValue: Integer);
    Function    GetKnobParamValue: TMimValue;
    Procedure   SetKnobParamValue( aValue: TMimValue);
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   Execute;                                               Override;
  Published
    Property    K1             : TMimValue  Read GetK1             Write SetK1;
    Property    K2             : TMimValue  Read GetK2             Write SetK2;
    Property    K3             : TMimValue  Read GetK3             Write SetK3;
    Property    K4             : TMimValue  Read GetK4             Write SetK4;
    Property    K5             : TMimValue  Read GetK5             Write SetK5;
    Property    K6             : TMimValue  Read GetK6             Write SetK6;
    Property    K7             : TMimValue  Read GetK7             Write SetK7;
    Property    K8             : TMimValue  Read GetK8             Write SetK8;
    Property    K9             : TMimValue  Read GetK9             Write SetK9;
    Property    K10            : TMimValue  Read GetK10            Write SetK10;
    Property    Algorithm      : Integer Read FAlgorithm        Write SetAlgorithm;
    Property    KnobParamValue : TMimValue  Read GetKnobParamValue Write SetKnobParamValue;
  End;


  TMimScope = Class( TMimCustomModule)
  Private
      FInp         : TMimInput;
      FTrig        : TMimInput;
      FSens        : TMimKnob;
      FGraph       : TMimGraphSheet;
      FSensitivity : TMimValue;
      FDataPtr     : Integer;
      FRunning     : Boolean;
      FOldTrig     : TMimValue;
    Procedure   SenseValueChanged( anObject: TObject; aValue: TMimValue);
    Function    GetSenseValue: TMimValue;
    Procedure   SetSenseValue( aValue: TMimValue);
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   Execute;                                               Override;
  Published
    Property    SenseValue: TMimValue Read GetSenseValue Write SetSenseValue;
  End;

  TMimMorph = Class( TMimCustomModule)
  Private
      FIn1_1       : TMimInput;
      FIn1_2       : TMimInput;
      FIn1_3       : TMimInput;
      FIn1_4       : TMimInput;
      FIn1_5       : TMimInput;
      FIn1_6       : TMimInput;
      FIn1_7       : TMimInput;
      FIn1_8       : TMimInput;
      FIn1_9       : TMimInput;
      FIn1_10      : TMimInput;
      FIn1_11      : TMimInput;
      FIn2_1       : TMimInput;
      FIn2_2       : TMimInput;
      FIn2_3       : TMimInput;
      FIn2_4       : TMimInput;
      FIn2_5       : TMimInput;
      FIn2_6       : TMimInput;
      FIn2_7       : TMimInput;
      FIn2_8       : TMimInput;
      FIn2_9       : TMimInput;
      FIn2_10      : TMimInput;
      FIn2_11      : TMimInput;
      FInSelect    : TMimInput;
      FOut_1       : TMimOutput;
      FOut_2       : TMimOutput;
      FOut_3       : TMimOutput;
      FOut_4       : TMimOutput;
      FOut_5       : TMimOutput;
      FOut_6       : TMimOutput;
      FOut_7       : TMimOutput;
      FOut_8       : TMimOutput;
      FOut_9       : TMimOutput;
      FOut_10      : TMimOutput;
      FOut_11      : TMimOutput;
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   Execute;                                               Override;
  End;

  TMimSlotCtrl = Class( TMimCustomModule)
  Private
      FButtonStart : TMimPushButton;
      FButtonStop  : TMimPushButton;
      FActive      : Boolean;
    Procedure   ButtonPress( aSender: TObject; aValue: Boolean);
    Procedure   SetActive( aValue: Boolean);
  Protected
    Procedure   CreateDetails;                                         Override;
  Published
    Property    Active : Boolean Read FActive Write SetActive;
  End;

  TMimShifter = Class( TMimCustomModule)
  Private
      FIn          : TMimInput;
      FOut_1       : TMimOutput;
      FOut_2       : TMimOutput;
      FOut_3       : TMimOutput;
      FOut_4       : TMimOutput;
      FOut_5       : TMimOutput;
      FOut_6       : TMimOutput;
      FOut_7       : TMimOutput;
      FOut_8       : TMimOutput;
      FOut_9       : TMimOutput;
      FOut_10      : TMimOutput;
      FKnobDelay   : TMimKnob;
      FDelayValue  : Integer;
      FCount       : Integer;
    Procedure   DelayValueChanged( anObject: TObject; aValue: TMimValue);
    Function    GetDelayValue: TMimValue;
    Procedure   SetDelayValue( aValue: TMimValue);
  Protected
    Procedure   CreateDetails;                                         Override;
  Public
    Procedure   Execute;                                               Override;
  Published
    Property    DelayValue: TMimValue Read GetDelayValue Write SetDelayValue;
  End;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

Implementation

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


{ =========
  TConstant = Class( TModule)
  Private
      FKnobAmp : TKnob;
      FOut     : TOutput;
  Published
    Property    KnobAmpValue  : Integer Read GetKnobAmpValue  Write SetKnobAmpValue;
  Private
}

    Procedure   TMimConstant.KnobAmpValChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FOut.Value := aValue;
    End;

    Function    TMimConstant.GetKnobAmpValue: TMimValue;
    Begin
      Result := FKnobAmp.Value;
    End;

    Procedure   TMimConstant.SetKnobAmpValue( aValue: TMimValue);
    Begin
      FKnobAmp.Value := aValue;
    End;

//  Protected

    Procedure   TMimConstant.CreateDetails; // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;
      FOut := TMimOutput( CreateDetail( Width - 23, 30, 'Out', TMimOutput));
      With FOut Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := Round( 0.75 * UnityValue);
      End;
      V := TMimViewer( CreateDetail( 190,  2, '', TMimViewer));
      V.Width := V.Width - 2;
      FKnobAmp := TMimKnob( CreateDetail(  193, 18, '', TMimKnob));
      With FKnobAmp Do
      Begin
        Viewer        := V;
        MinValue      := - UnityValue;
        MaxValue      :=   UnityValue;
        Step          := UnityValue Div 250;
        Value         := Round( 0.75 * UnityValue);
        OnValueChange := KnobAmpValChanged;
        FOut.Value    := Value;
      End;
    End;


{ ========
  TAmplifier = Class( TModule)
  Private
      FKnobAmp   : TKnob;
      FKnobClip  : TKnob;
      FIn        : TInput;
      FInClip    : TInput;
      FOut       : TOutput;
      FAmplitude : TValue;
      FClipLevel : TValue;
  Published
    Property    KnobAmpValue  : TValue Read GetKnobAmpValue  Write SetKnobAmpValue;
    Property    KnobClipValue : TValue Read GetKnobClipValue Write SetKnobClipValue;
  Private
}

    Procedure   TMimAmplifier.KnobAmpValChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FAmplitude := aValue;
    End;

    Procedure   TMimAmplifier.KnobClipValChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FClipLevel := aValue;
      If FClipLevel = 0
      Then FKnobClip.Viewer.Text := 'Off';
    End;

    Function    TMimAmplifier.GetKnobAmpValue: TMimValue;
    Begin
      Result := FKnobAmp.Value;
    End;

    Procedure   TMimAmplifier.SetKnobAmpValue( aValue: TMimValue);
    Begin
      FKnobAmp.Value := aValue;
    End;

    Function    TMimAmplifier.GetKnobClipValue : TMimValue;
    Begin
      Result := FKnobClip.Value;
    End;

    Procedure   TMimAmplifier.SetKnobClipValue ( aValue: TMimValue);
    Begin
      FKnobClip.Value := aValue;
    End;

//  Protected

    Procedure   TMimAmplifier.CreateDetails; // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;

      FIn := TMimInput( CreateDetail( 8, 30, 'In', TMimInput));
      With FIn Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;
      With TMimTextLabel( CreateDetail( 10, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'in';
        AutoSize := False;
      End;

      FInClip := TMimInput( CreateDetail( 30, 30, 'InClip', TMimInput));
      With FInClip Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;
      With TMimTextLabel( CreateDetail( 29, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'clip';
        AutoSize := False;
      End;

      FOut := TMimOutput( CreateDetail( Width - 23, 30, 'Out',  TMimOutput));
      With FOut Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;

      V  := TMimViewer( CreateDetail( 186, 2, '', TMimViewer));
      V.Width := V.Width + 6;
      FKnobAmp := TMimKnob( CreateDetail( 193, 18, '', TMimKnob));
      With FKnobAmp Do
      Begin
        Viewer        := V;
        MinValue      := - 10 * UnityValue;
        MaxValue      :=   10 * UnityValue;
        Step          := 10 * UnityValue Div 250;
        Value         := Round( 0.75 * UnityValue);
        OnValueChange := KnobAmpValChanged;
        FAmplitude    := Value;
      End;

      V  := TMimViewer( CreateDetail( 96, 2, '', TMimViewer));
      V.Width := V.Width - 2;
      FKnobClip := TMimKnob( CreateDetail( 99, 18, '', TMimKnob));
      With FKnobClip Do
      Begin
        Viewer        := V;
        MinValue      := 0;
        MaxValue      := UnityValue;
        Step          := UnityValue Div 250;
        Value         := 1;
        Value         := 0;
        OnValueChange := KnobClipValChanged;
        FClipLevel    := Value;
      End;
    End;

//  Public

    Procedure   TMimAmplifier.Execute; // Override;
    Var
      aClip  : TMimValue;
      aValue : TMimValue;
    Begin
      If FInClip.Connected
      Then aClip := Abs( FInClip.Value)
      Else aClip := FKnobClip.Value;
      aValue := FIn.Value;
      Clip( aValue, - aClip, aClip);
      FOut.Value := Round( FAmplitude * aValue / UnityValue);
    End;


{ ========
  TMultiplier = Class( TModule)
  Private
      FKnobAmp   : TKnob;
      FIn1       : TInput;
      FIn2       : TInput;
      FOut       : TOutput;
      FInLabel   : TTextLabel;
      FAmplitude : TValue;
  Published
    Property    KnobAmpValue  : Integer Read GetKnobAmpValue  Write SetKnobAmpValue;
  Private
}

    Procedure   TMimMultiplier.KnobAmpValChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FAmplitude := aValue;
    End;

    Function    TMimMultiplier.GetKnobAmpValue: TMimValue;
    Begin
      Result := FKnobAmp.Value;
    End;

    Procedure   TMimMultiplier.SetKnobAmpValue( aValue: TMimValue);
    Begin
      FKnobAmp.Value := aValue;
    End;

//  Protected

    Procedure   TMimMultiplier.CreateDetails; // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;
      FIn1 := TMimInput( CreateDetail( 8, 30, 'In1', TMimInput));
      With FIn1 Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;
      FInLabel := TMimTextLabel( CreateDetail( 15, 14, '', TMimTextLabel));
      With FInLabel Do
      Begin
        AutoSize := True;
        Text     := '1 x 2';
        AutoSize := False;
      End;

      FIn2 := TMimInput( CreateDetail( 30, 30, 'In2', TMimInput));
      With FIn2 Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;

      FOut := TMimOutput( CreateDetail( Width - 23, 30, 'Out', TMimOutput));
      With FOut Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;

      V := TMimViewer( CreateDetail( 190,  2, '', TMimViewer));
      V.Width := V.Width - 2;
      FKnobAmp := TMimKnob( CreateDetail(  193, 18, '', TMimKnob));
      With FKnobAmp Do
      Begin
        Viewer        := V;
        MinValue      := - UnityValue;
        MaxValue      :=   UnityValue;
        Step          := UnityValue Div 250;
        Value         := Round( 0.75 * UnityValue);
        OnValueChange := KnobAmpValChanged;
        FAmplitude    := Value;
      End;
    End;

//  Public

    Procedure   TMimMultiplier.Execute; // Override;
    Begin
      FOut.Value := Round( FAmplitude * FIn1.Value *FIn2.Value / ( UnityValue * UnityValue));
    End;


{ ========
  TDivider = Class( TMultiplier)
  Protected
}

    Procedure   TMimDivider.CreateDetails; // Override;
    Begin
      Inherited CreateDetails;

      With FInLabel Do
      Begin
        AutoSize := True;
        Text     := '1 / 2';
        AutoSize := False;
      End;
    End;

//  Public


    Procedure   TMimDivider.Execute; // Override;
    Var
      aValue1 : TMimValue;
      aValue2 : TMimValue;
      aValue  : TMimValue;
    Begin
      aValue1 := FIn1.Value;
      aValue2 := FIn2.Value;
      If aValue2 = 0
      Then Begin
        If aValue1 > 0
        Then  aValue := UnityValue
        Else If aValue1 < 0
        Then aValue := - UnityValue
        Else aValue := 0;
      End
      Else aValue := Round( FAmplitude * ( aValue1 / aValue2) / ( UnityValue * UnityValue));
      FOut.Value := aValue;
    End;


{ ========
  TOscillator = Class( TModule)
  Private
      FKnobFreq  : TKnob;
      FIndicator : TIndicator;
      FKnobAmp   : TKnob;
      FButton    : TPushButton;
      FButSym    : TPushButton;
      FButRng    : TPushButton;
      FOut       : TOutput;
      FSync      : TInput;
      FInFmMod   : TInput;
      FInAmMod   : TInput;
      FActive    : Boolean;
      FSymetric  : Boolean;
      FCounter   : Integer;
      FTime      : TValue;
      FLimit     : TValue;
      FAmplitude : TValue;
      FampMax    : TValue;
      FPrevSync  : TValue;
      FRange     : Integer;
      FDisplay   : TTextLabel;
  Published
    Property    Range         : Integer Read FRange           Write SetRange;
    Property    KnobFreqValue : Integer Read GetKnobFreqValue Write SetKnobFreqValue;
    Property    KnobAmpValue  : Integer Read GetKnobAmpValue  Write SetKnobAmpValue;
    Property    ButtonDown    : Boolean Read GetButtonDown    Write SetButtonDown;
    Property    ButSymDown    : Boolean Read GetButSymDown    Write SetButSymDown;
  Private
}


    Procedure   TMimOscillator.KnobFreqValChanged( aSender: TObject; aValue: TMimValue); // Virtual;
    Var
      aTime : Double;
    Begin
      aTime := aValue / MainTimeResolution;
      If aTime <= 0
      Then aTime := 1.0;
      Case Range Of
        1 : FTime := Round( aTime        );
        2 : FTime := Round( aTime *  1000);
        3 : FTime := Round( aTime * 60000);
      End;
    End;

    Procedure   TMimOscillator.KnobAmpValChanged ( aSender: TObject; aValue: TMimValue);
    Begin
      FAmpMax := aValue;
    End;

    Procedure   TMimOscillator.ButtonValueChanged( aSender: TObject; aValue: Boolean);
    Begin
      FActive := aValue;
    End;

    Procedure   TMimOscillator.ButSymValueChanged( aSender: TObject; aValue: Boolean);
    Begin
      FSymetric := aValue;
      If FSymetric
      Then FOut.ConnectorType := ctSymmetric
      Else FOut.ConnectorType := ctAsymmetric;
    End;

    Procedure   TMimOscillator.ButRngClicked( aSender: TObject);
    Begin
      TMimPushButton( aSender).Down := False;
      Range := 1 + Range Mod 3
    End;

    Function    TMimOscillator.GetKnobFreqValue: TMimValue;
    Begin
      Result := FKnobFreq.Value;
    End;

    Procedure   TMimOscillator.SetKnobFreqValue( aValue: TMimValue);
    Begin
      FKnobFreq.Value := aValue;
    End;

    Function    TMimOscillator.GetKnobAmpValue: TMimValue;
    Begin
      Result := FKnobAmp.Value;
    End;

    Procedure   TMimOscillator.SetKnobAmpValue( aValue: TMimValue);
    Begin
      FKnobAmp.Value := aValue;
    End;

    Function    TMimOscillator.GetButtonDown: Boolean;
    Begin
      Result := FButton.Down;
    End;

    Procedure   TMimOscillator.SetButtonDown( aValue: Boolean);
    Begin
      FButton.Down := aValue;
    End;

    Function    TMimOscillator.GetButSymDown: Boolean;
    Begin
      Result := FButSym.Down;
    End;

    Procedure   TMimOscillator.SetButSymDown( aValue: Boolean);
    Begin
      FButSym.Down := aValue;
    End;

    Procedure   TMimOscillator.SetRange( aValue: Integer); // Virtual;
    Begin
      If aValue <> FRange
      Then Begin
        FRange := aValue;
        With FKnobFreq Do
        Begin
          Case FRange Of
            1 : Begin
                MinValue := 60;
                MaxValue := 4500;
                Step     := 30;
                FDisplay.Text := 'ms';
              End;
            2 : Begin
                MinValue := 2;
                MaxValue := 150;
                Step     := 1;
                FDisplay.Text := ' s';
              End;
            3 : Begin
                MinValue := 1;
                MaxValue := 250;
                Step     := 1;
                FDisplay.Text := ' m';
              End;
          End;
        End;
      End;
    End;

{  Protected }

    Procedure   TMimOscillator.CreateDetails; // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;

      FOut := TMimOutput( CreateDetail( Width - 23, 30, 'Out', TMimOutput));
      With FOut Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;

      FSync := TMimInput( CreateDetail( 35, 30, 'Sync', TMimInput));
      With FSync Do
      Begin
        ConnectorType := ctLogic;
        Value         := 0;
      End;
      FLabelSync := TMimTextLabel( CreateDetail( 35, 14, '', TMimTextLabel));
      With FLabelSync Do
      Begin
        AutoSize    := True;
        Text        := 'snc';
        AutoSize    := False;
        ParentColor := False;
        TextColor   := clBlack;
      End;

      FInFmMod := TMimInput( CreateDetail( 52, 30, 'InFmMod', TMimInput));
      With FInFmMod Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;
      With TMimTextLabel( CreateDetail( 54, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize    := True;
        Text        := 'fm';
        AutoSize    := False;
        ParentColor := False;
        TextColor   := clBlack;
      End;

      FInAmMod := TMimInput( CreateDetail( 86, 30, 'InAmMod', TMimInput));
      With FInAmMod Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;
      With TMimTextLabel( CreateDetail( 86, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize    := True;
        Text        := 'am';
        AutoSize    := False;
        ParentColor := False;
        TextColor   := clBlack;
      End;

      V         := TMimViewer( CreateDetail( 110,  2, '', TMimViewer));
      V.Width   := V.Width - 2;
      FCounter  :=  0;
      FLimit    := 50;
      FKnobFreq := TMimKnob( CreateDetail(  112, 18, '', TMimKnob));
      With FKnobFreq Do
      Begin
        Viewer        := V;
        MinValue      := ShortestTime;
        MaxValue      := LongestTime;
        Step          := 60;
        Value         := 500;
        OnValueChange := KnobFreqValChanged;
      End;
      FDisplay := TMimTextLabel( CreateDetail( 142, 21, '', TMimTextLabel));
      With FDisplay Do
      Begin
        AutoSize    := True;
        Text        := 'ms';
        AutoSize    := False;
        ParentColor := False;
        TextColor   := clBlack;
      End;

      FButRng := TMimPushButton( CreateDetail( 142, 32, '', TMimPushButton));
      With FButRng Do
      Begin
        Height     := 15;
        Width      := 15;
        AllowAllup := True;
        Down       := False;
        OnClick    := ButRngClicked;
      End;

      V := TMimViewer( CreateDetail( 188,  2, '', TMimViewer));
      V.Width := V.Width - 2;
      FKnobAmp := TMimKnob( CreateDetail(  192, 18, '', TMimKnob));
      With FKnobAmp Do
      Begin
        Viewer        := V;
        MinValue      := - UnityValue;
        MaxValue      :=   UnityValue;
        Step          := UnityValue Div 250;
        Value         := Round( 0.75 * UnityValue);
        OnValueChange := KnobAmpValChanged;
        FAmpMax       := Value;
      End;

      FIndicator := TMimLed( CreateDetail( Width - 20, 20, '', TMimLed));
      FActive := False;

      FButSym := TMimPushButton( CreateDetail( 222, 2, '', TMimPushButton));
      With FButSym Do
      Begin
        LoadBitmap( 'Sym.bmp');
        Height        := 15;
        AllowAllUp    := True;
        OnValueChange := ButSymValueChanged;
        Down          := True;
      End;

      FSymetric := FButSym.Down;
      Range     := 0;
      Range     := 1;
    End;

{  Public }

    Procedure   TMimOscillator.Execute; // Override;
    Var
      aValue : TMimValue;
    Begin
      If Not FActive
      Then Exit;

      If FInFmMod.Connected
      Then Begin
        aValue := 1000 + FInFmMod.Value;
        If aValue <= 0
        Then aValue := 1;
        FLimit := Round( FTime * 1000 / aValue);
      End
      Else FLimit := FTime;
      If FLimit <= 0
      Then FLimit := 1;

      If FInAmMod.Connected
      Then FAmplitude := FampMax * FinAmMod.Value Div 1000
      Else FAmplitude := FAmpMax;

      Inc( FCounter);
      If ( FCounter < 0) Or ( FCounter >= FLimit)
      Then FCounter := 0;

      aValue := FSync.Value;
      If ( aValue > 0) And ( FPrevSync <= 0)
      Then FCounter := 0;
      FPrevSync := aValue;

      PerformExec;

      If FSymetric
      Then FIndicator.Active := FOut.Value > 0
      Else FIndicator.Active := FOut.Value > FAmplitude Div 2;
    End;

    Procedure   TMimOscillator.PerformExec; // Override;
    Begin
      // Abstract
    End;


{ ========
  TSquare = Class( TOscillator)
  Private
      FInPwMod    : TInput;
      FKnobWidth  : TKnob;
      FPulseWidth : TValue;
  Published
    Property    KnobWidthValue : Integer Read FKnobWidthValue Write SetKnobWidthValue;
  Private
}

    Procedure   TMimSquare.KnobWidthChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FPulseWidth := aValue;
    End;

    Function    TMimSquare.GetKnobWidthValue: TMimValue;
    Begin
      Result := FKnobWidth.Value;
    End;

    Procedure   TMimSquare.SetKnobWidthValue( aValue: TMimValue);
    Begin
      FKnobWidth.Value := aValue;
    End;

//  Protected

    Procedure   TMimSquare.CreateDetails; // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;

      FInPwMod := TMimInput( CreateDetail( 69, 30, 'InPwMod', TMimInput));
      With FInPwMod Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;
      With TMimTextLabel( CreateDetail( 69, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize    := True;
        Text        := 'pw';
        AutoSize    := False;
        ParentColor := False;
        TextColor   := clBlack;
      End;

      FButton := TMimPushButton( CreateDetail( 5, 20, '', TMimPushButton));
      With FButton Do
      Begin
        LoadBitmap( 'Square.bmp');
        AllowAllUp    := True;
        OnValueChange := ButtonValueChanged;
        Down          := True;
      End;
      FActive := FButton.Down;


      V := TMimViewer( CreateDetail( 165, 2, '', TMimViewer));
      V.Width := V.Width - 15;
      FKnobWidth := TMimKnob( CreateDetail( 162, 18, '', TMimKnob));
      With FKnobWidth Do
      Begin
        OnValueChange := KnobWidthChanged;
        Viewer        := V;
        MinValue      :=  1;
        MaxValue      := 99;
        Step          :=  1;
        Value         := 50;
        FPulseWidth   := Value;
      End;
    End;

{  Public }

    Procedure   TMimSquare.PerformExec; // Override;
    Var
      aLim : TMimValue;
    Begin
      If FInPwMod.Connected
      Then aLim := Round( FLimit * ( FinPwMod.Value + 1000) / 2000 * ( FPulseWidth / 100))
      Else aLim := FLimit * FPulseWidth Div 100;
      If aLim <= 0
      Then aLim := 1;
      With FOut Do
      Begin
        If FCounter > aLim
        Then Begin
          If FSymetric
          Then Value := - FAmplitude
          Else Value := 0;
        End
        Else Value := FAmplitude;
      End;
    End;


{ ========
  TSine = Class( TOscillator)
  Protected
}

    Procedure   TMimSine.CreateDetails; // Override;
    Begin
      Inherited CreateDetails;
      FButton := TMimPushButton( CreateDetail( 5, 20, '', TMimPushButton));
      With FButton Do
      Begin
        LoadBitmap( 'Sine.bmp');
        AllowAllUp    := True;
        OnValueChange := ButtonValueChanged;
        Down          := True;
      End;
      FActive := FButton.Down;
    End;

{  Public }

    Procedure   TMimSine.PerformExec; // Override;
    Begin
      With FOut Do
      Begin
        If FSymetric
        Then Value := Round( FAmplitude * Sin( 2 * Pi * FCounter / FLimit))
        Else Value := Round(( FAmplitude + FAmplitude * Sin( 2 * Pi * FCounter / FLimit)) / 2);
      End;
    End;


{ ========
  TSaw = Class( TOscillator)
  Protected
}

    Procedure   TMimSaw.CreateDetails; // Override;
    Begin
      Inherited CreateDetails;
      FButton := TMimPushButton( CreateDetail( 5, 20, '', TMimPushButton));
      With FButton Do
      Begin
        LoadBitmap( 'Saw.bmp');
        AllowAllUp    := True;
        OnValueChange := ButtonValueChanged;
        Down          := True;
      End;
      FActive := FButton.Down;
    End;

{  Public }

    Procedure   TMimSaw.PerformExec; // Override;
    Begin
      With FOut Do
      Begin
        If FSymetric
        Then Value := Round( FAmplitude * (( 2 * FCounter / FLimit) - 1))
        Else Value := Round( FAmplitude * FCounter / FLimit);
      End;
    End;


{ ========
  TRandom = Class( TOscillator)
  Private
      FInColorMod : TInput;
      FKnobColor  : TKnob;
      FRndColor   : Integer;
  Published
    Property    KnobColorValue : Integer Read GetKnobColorValue Write SetKnobColorValue;
  Private
}

    Procedure   TMimRandom.KnobColorChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FRndColor := aValue;
    End;

    Function    TMimRandom.GetKnobColorValue: TMimValue;
    Begin
      Result := FKnobColor.Value;
    End;

    Procedure   TMimRandom.SetKnobColorValue( aValue: TMimValue);
    Begin
      FKnobColor.Value := aValue;
    End;

//  Protected


    Procedure   TMimRandom.CreateDetails; // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;

      FInColorMod := TMimInput( CreateDetail( 69, 30, 'InColorMod', TMimInput));
      With FInColorMod Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;
      With TMimTextLabel( CreateDetail( 69, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize    := True;
        Text        := 'clr';
        AutoSize    := False;
        ParentColor := False;
        TextColor   := clBlack;
      End;

      FButton := TMimPushButton( CreateDetail( 5, 20, '', TMimPushButton));
      With FButton Do
      Begin
        LoadBitmap( 'Random.bmp');
        AllowAllUp    := True;
        OnValueChange := ButtonValueChanged;
        Down          := True;
      End;
      FActive := FButton.Down;

      V := TMimViewer( CreateDetail( 165, 2, '', TMimViewer));
      V.Width := V.Width - 15;
      FKnobColor := TMimKnob( CreateDetail( 162, 18, '', TMimKnob));
      With FKnobColor Do
      Begin
        OnValueChange := KnobColorChanged;
        Viewer        := V;
        MinValue      :=  0;
        MaxValue      := 99;
        Step          :=  1;
        Value         := 50;
        FRndColor     := Value;
      End;
    End;

{  Public }

    Procedure   TMimRandom.PerformExec; // Override;
    Var
      aValue : TMimValue;
      aCol   : TMimValue;
    Begin
      If FCounter = 0
      Then Begin
        If FInColorMod.Connected
        Then aCol := FRndColor * FInColorMod.Value Div UnityValue
        Else aCol := FRndColor;

        Clip( aCol, 1, 100);

        aValue := Round((( 100 - aCol) * FAmplitude * ( 1 - 2 * Random) + aCol * FOut.Value) / 100);

        If Not FSymetric
        Then aValue := Abs( aValue);

        FOut.Value := aValue;
      End;
    End;


{ ========
  TRndPulse = Class( TOscillator)
  Protected
}

    Procedure   TMimRndPulse.CreateDetails; // Override;
    Begin
      Inherited CreateDetails;
      FButton := TMimPushButton( CreateDetail( 5, 20, '', TMimPushButton));
      With FButton Do
      Begin
        LoadBitmap( 'RndPulse.bmp');
        AllowAllUp    := True;
        OnValueChange := ButtonValueChanged;
        Down          := True;
      End;
      FActive := FButton.Down;
    End;

{  Public }

    Procedure   TMimRndPulse.PerformExec; // Override;
    Begin
      If FCounter = 0
      Then Begin
        With FOut Do
          If Value <= 0
          Then Value := FAmplitude
          Else
            If FSymetric
            Then Value := - FAmplitude
            Else Value := 0;
        FCounter := Random( Round( FLimit));
      End;
    End;


{ ========
  TClockedOscillator = Class( TOscillator)
  Private
}

    Procedure   TMimClockedOscillator.KnobFreqValChanged( aSender: TObject; aValue: TMimValue); // Override;
    Begin
      FTime := aValue;
      If FTime <= 0
      Then FTime := 1;
      Case Range Of
        2 : FTime := FTime *   100;
        3 : FTime := FTime * 10000;
      End;
    End;

    Procedure   TMimClockedOscillator.SetRange( aValue: Integer); // Override;
    Begin
      If aValue <> FRange
      Then Begin
        FRange := aValue;
        Case FRange Of
          1 : FDisplay.Text := 'e0';
          2 : FDisplay.Text := 'e2';
          3 : FDisplay.Text := 'e4';
        End;
      End;
    End;

//  Protected

    Procedure   TMimClockedOscillator.CreateDetails; // Override;
    Begin
      Inherited CreateDetails;
      With FLabelSync Do
        Text := 'clk';
      With FKnobFreq Do
      Begin
        MinValue :=   1;
        MaxValue := 250;
        Step     :=   1;
        Value    :=   2;
      End;
      Range := 1;
      Range := 0;
    End;

//  Public

    Procedure   TMimClockedOscillator.Execute; // Override;
    Var
      aValue : TMimValue;
      bValue : TMimValue;
    Begin
      If Not FActive
      Then Exit;

      aValue := FSync.Value;
      If
        ( aValue >  0) And ( FPrevSync <= 0) Or
        ( aValue <= 0) And ( FPrevSync >  0)
      Then Begin
        If FInFmMod.Connected
        Then Begin
          bValue := 1000 + FInFmMod.Value;
          If bValue <= 0
          Then bValue := 1;
          FLimit := Round( FTime * 1000 / bValue);
        End
        Else FLimit := FTime;
        If FLimit <= 0
        Then FLimit := 1;

        If FInAmMod.Connected
        Then FAmplitude := FampMax * FinAmMod.Value Div 1000
        Else FAmplitude := FAmpMax;

        If ( FCounter < 0) Or ( FCounter >= FLimit)
        Then FCounter := 0
        Else FCounter := ( FCounter + 1) Mod FLimit;

        PerformExec;

        If FSymetric
        Then FIndicator.Active := FOut.Value > 0
        Else FIndicator.Active := FOut.Value > FAmplitude Div 2;
      End;
      FPrevSync := aValue;

    End;


{ ========
  TClSquare = Class( TClockedOscillator)
  Private
      FInPwMod    : TInput;
      FKnobWidth  : TKnob;
      FPulseWidth : TValue;
  Published
    Property    KnobWidthValue : Integer Read FKnobWidthValue Write SetKnobWidthValue;
  Private
}

    Procedure   TMimClSquare.KnobWidthChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FPulseWidth := aValue;
    End;

    Function    TMimClSquare.GetKnobWidthValue: TMimValue;
    Begin
      Result := FKnobWidth.Value;
    End;

    Procedure   TMimClSquare.SetKnobWidthValue( aValue: TMimValue);
    Begin
      FKnobWidth.Value := aValue;
    End;

//  Protected

    Procedure   TMimClSquare.CreateDetails; // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;

      FInPwMod := TMimInput( CreateDetail( 69, 30, 'InPwMod', TMimInput));
      With FInPwMod Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;
      With TMimTextLabel( CreateDetail( 69, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize    := True;
        Text        := 'pw';
        AutoSize    := False;
        ParentColor := False;
        TextColor   := clBlack;
      End;

      FButton := TMimPushButton( CreateDetail( 5, 20, '', TMimPushButton));
      With FButton Do
      Begin
        LoadBitmap( 'ClSquare.bmp');
        AllowAllUp    := True;
        OnValueChange := ButtonValueChanged;
        Down          := True;
      End;
      FActive := FButton.Down;


      V := TMimViewer( CreateDetail( 165, 2, '', TMimViewer));
      V.Width := V.Width - 15;
      FKnobWidth := TMimKnob( CreateDetail( 162, 18, '', TMimKnob));
      With FKnobWidth Do
      Begin
        OnValueChange := KnobWidthChanged;
        Viewer        := V;
        MinValue      :=  1;
        MaxValue      := 99;
        Step          :=  1;
        Value         := 50;
        FPulseWidth   := Value;    
      End;
    End;

{  Public }

    Procedure   TMimClSquare.PerformExec; // Override;
    Var
      aLim : TMimValue;
    Begin
      If FInPwMod.Connected
      Then aLim := Round(( FLimit * ( FinPwMod.Value + 1000) / 2000) * ( FPulseWidth / 100))
      Else aLim := FLimit * FPulseWidth Div 100;
      Clip( aLim, 1, FLimit - 2);
      With FOut Do
      Begin
        If FCounter > aLim
        Then Begin
          If FSymetric
          Then Value := - FAmplitude
          Else Value := 0;
        End
        Else Value := FAmplitude;
      End;
    End;


{ ========
  TClSine = Class( TClockedOscillator)
  Protected
}

    Procedure   TMimClSine.CreateDetails; // Override;
    Begin
      Inherited CreateDetails;

      FButton := TMimPushButton( CreateDetail( 5, 20, '', TMimPushButton));
      With FButton Do
      Begin
        LoadBitmap( 'ClSine.bmp');
        AllowAllUp    := True;
        OnValueChange := ButtonValueChanged;
        Down          := True;
      End;
      FActive := FButton.Down;
    End;

{  Public }

    Procedure   TMimClSine.PerformExec; // Override;
    Begin
      With FOut Do
      Begin
        If FSymetric
        Then Value := Round( FAmplitude * Sin( 2 * Pi * FCounter / FLimit))
        Else Value := Round(( FAmplitude + FAmplitude * Sin( 2 * Pi * FCounter / FLimit)) / 2);
      End;
    End;


{ ========
  TClSaw = Class( TClockedOscillator)
  Protected
}

    Procedure   TMimClSaw.CreateDetails; // Override;
    Begin
      Inherited CreateDetails;

      FButton := TMimPushButton( CreateDetail( 5, 20, '', TMimPushButton));
      With FButton Do
      Begin
        LoadBitmap( 'ClSaw.bmp');
        AllowAllUp    := True;
        OnValueChange := ButtonValueChanged;
        Down          := True;
      End;
      FActive := FButton.Down;
    End;

{  Public }

    Procedure   TMimClSaw.PerformExec; // Override;
    Begin
      With FOut Do
      Begin
        If FSymetric
        Then Value := Round( FAmplitude * (( 2 * FCounter / FLimit) - 1))
        Else Value := Round( FAmplitude * FCounter / FLimit);
      End;
    End;


{ ========
  TClRandom = Class( TClockedOscillator)
  Private
      FInColorMod : TInput;
      FKnobColor  : TKnob;
      FRndColor   : Integer;
  Published
    Property    KnobColor : Integer Read GetKnobColorValue Write SetKnobColorValue;
  Private
}

    Procedure   TMimClRandom.KnobColorChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FRndColor := aValue;
    End;

    Function    TMimClRandom.GetKnobColorValue: TMimValue;
    Begin
      Result := FKnobColor.Value;
    End;

    Procedure   TMimClRandom.SetKnobColorValue( aValue: TMimValue);
    Begin
      FKnobColor.Value := aValue;
    End;

//  Protected

    Procedure   TMimClRandom.CreateDetails; // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;

      FInColorMod := TMimInput( CreateDetail( 69, 30, 'InColorMod', TMimInput));
      With FInColorMod Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;
      With TMimTextLabel( CreateDetail( 69, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize    := True;
        Text        := 'clr';
        AutoSize    := False;
        ParentColor := False;
        TextColor   := clBlack;
      End;

      FButton := TMimPushButton( CreateDetail( 5, 20, '', TMimPushButton));
      With FButton Do
      Begin
        LoadBitmap( 'ClRandom.bmp');
        AllowAllUp    := True;
        OnValueChange := ButtonValueChanged;
        Down          := True;
      End;
      FActive := FButton.Down;

      V := TMimViewer( CreateDetail( 165, 2, '', TMimViewer));
      V.Width := V.Width - 15;
      FKnobColor := TMimKnob( CreateDetail( 162, 18, '', TMimKnob));
      With FKnobColor Do
      Begin
        OnValueChange := KnobColorChanged;
        Viewer        := V;
        MinValue      :=  0;
        MaxValue      := 99;
        Step          :=  1;
        Value         := 50;
        FRndColor     := Value;
      End;
    End;

{  Public }

    Procedure   TMimClRandom.PerformExec; // Override;
    Var
      aCol   : TMimValue;
      aValue : TMimValue;
    Begin
      If FCounter = 0
      Then Begin
        If FInColorMod.Connected
        Then aCol := FRndColor * FInColorMod.Value Div 1000
        Else aCol := FRndColor;

        If aCol < 1
        Then aCol := 1
        Else If aCol > 100
        Then aCol := 100;

        aValue := Round((( 100 - aCol) * FAmplitude * ( 1 - 2 * Random) + aCol * FOut.Value) / 100);

        If Not FSymetric
        Then aValue := Abs( aValue);

        FOut.Value := aValue;
      End;
    End;


{ ========
  TClRndPulse = Class( TClockedOscillator)
  Protected
}

    Procedure   TMimClRndPulse.CreateDetails; // Override;
    Begin
      Inherited CreateDetails;

      FButton := TMimPushButton( CreateDetail( 5, 20, '', TMimPushButton));
      With FButton Do
      Begin
        LoadBitmap( 'ClRndPulse.bmp');
        AllowAllUp    := True;
        OnValueChange := ButtonValueChanged;
        Down          := True;
      End;
      FActive := FButton.Down;
    End;

{  Public }

    Procedure   TMimClRndPulse.PerformExec; // Override;
    Begin
      If FCounter = 0
      Then Begin
        With FOut Do
          If Value <= 0
          Then Value := FAmplitude
          Else
            If FSymetric
            Then Value := - FAmplitude
            Else Value := 0;
        FCounter := Random( FLimit);
      End;
    End;


{ ========
  TMidiIn = Class( TModule)
  Private
      FOutNote   : TOutput;
      FOutGate   : TOutput;
      FOutVel    : TOutput;
      FOutVelOff : TOutput;
      FIndicator : TIndicator;
      FKnobCh    : TKnob;
      FChannel   : Integer;
  Published
    Property    KnobChValue : Integer Read GetKnobChValue Write SetKnobChValue;
  Private
}

    Procedure   TMimMidiIn.KnobChValueChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FChannel := aValue - 1;
    End;

    Function    TMimMidiIn.GetKnobChValue: TMimValue;
    Begin
      Result := FKnobCh.Value;
    End;

    Procedure   TMimMidiIn.SetKnobChValue( aValue: TMimValue);
    Begin
      FKnobCh.Value := aValue;
    End;

// Protected

    Procedure   TMimMidiIn.CreateDetails;  // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;
      With TMimTextLabel( CreateDetail( 123, 14, '', TMimTextLabel))Do
      Begin
        AutoSize := True;
        Text := 'Note';
        AutoSize := False;
      End;
      FOutNote := TMimOutput( CreateDetail( 125, 30, 'OutNote', TMimOutput));
      With FOutNote Do
      Begin
        Value := 0;
      End;

      With TMimTextLabel( CreateDetail( 152, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := 'Gate';
        AutoSize := False;
      End;
      FOutGate := TMimOutput( CreateDetail( 155, 30, 'OutGate', TMimOutput));
      With FOutGate Do
      Begin
        ConnectorType := ctLogic;
        Value         := 0;
      End;

      With TMimTextLabel( CreateDetail( 185, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := 'Vel';
        AutoSize := False;
      End;
      FOutVel := TMimOutput( CreateDetail( 185, 30, 'OutVel', TMimOutput));
      With FOutVel Do
      Begin
        Value := 0;
      End;

      With TMimTextLabel( CreateDetail( 207, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := 'Rel vel';
        AutoSize := False;
      End;
      FOutVelOff := TMimOutput( CreateDetail( 215, 30, 'OutVelOff', TMimOutput));
      With FOutVelOff Do
      Begin
        Value := 0;
      End;

      FIndicator := TMimLed( CreateDetail( 159, 5, '', TMimLed));

      V := TMimViewer( CreateDetail( 91, 30, '', TMimViewer));
      V.Width := V.Width - 15;
      FKnobCh := TMimKnob( CreateDetail( 60, 18, '', TMimKnob));
      With FKnobCh Do
      Begin
        Viewer        := V;
        MinValue      := 1;
        MaxValue      := 16;
        Step          := 1;
        Value         := 1;
        OnValueChange := KnobChValueChanged;
        FChannel      := Value - 1;
      End;
      With TMimTextLabel( CreateDetail( 95, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := 'Ch';
        AutoSize := False;
      End;
    End;

    Procedure   TMimMidiIn.AcceptMidiShort( aShortMidi: TShortMidi); // Override;
    Var
      aCh     : Byte;
      anEvent : Byte;
      aData1  : Byte;
      aData2  : Byte;
    Begin
      DisAssembleShortMidi( aShortMidi, aCh, anEvent, aData1, aData2);
      If
        ( anEvent = CNoteOn) And
        ( aData2  = 0      )
      Then anEvent := CNoteOff;

      If
        ( anEvent = CNoteOn ) And
        ( aCh     = FChannel)
      Then Begin
        FOutNote  .Value  := aData1 * 8;
        FOutGate  .Value  := UnityValue;
        FOutVel   .Value  := aData2 * 8;
        FIndicator.Active := True;
      End
      Else If
        ( anEvent    = CNoteOff      ) And
        ( aCh        = FChannel      ) And
        ( aData1 * 8 = FOutNote.Value)
      Then Begin
        FOutGate  .Value  := 0;
        FOutVelOff.Value  := aData2 * 8;
        FIndicator.Active := False;
      End;
    End;


{ ========
  TMidiOut = Class( TModule)
  Private
      FInNote     : TInput;
      FInGate     : TInput;
      FInVel      : TInput;
      FInVelOff   : TInput;
      FInCh       : TInput;
      FIndicator  : TIndicator;
      FKnobCh     : TKnob;
      FButtonGate : TPushButton;
      FChannel    : Integer;
      FOldNote    : Integer;
      FOldGate    : Integer;
      FPrevChVal  : Integer;
      FGateActive : Boolean;
  Published
    Property    KnobChValue    : Integer Read GetKnobChValue     Write SetKnobChValue;
    Property    ButtonGateDown : Boolean Read GetButtonGateDown Write SetButtonGateDown;
  Private
}

    Procedure   TMimMidiOut.KnobChValueChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FChannel := aValue - 1;
    End;

    Procedure   TMimMidiOut.ButtonGateChanged( aSender: TObject; aValue: Boolean);
    Begin
      FGateActive := aValue;
    End;

    Function    TMimMidiOut.GetKnobChValue: TMimValue;
    Begin
      Result := FKnobCh.Value;
    End;

    Procedure   TMimMidiOut.SetKnobChValue( aValue: TMimValue);
    Begin
      FKnobCh.Value := aValue;
    End;

    Function    TMimMidiOut.GetButtonGateDown: Boolean;
    Begin
      Result := FButtonGate.Down;
    End;

    Procedure   TMimMidiOut.SetButtonGateDown( aValue: Boolean);
    Begin
      FButtonGAte.Down := aValue;
    End;

// Protected

    Procedure   TMimMidiOut.CreateDetails; // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;
      
      With TMimTextLabel( CreateDetail( 123, 14, '', TMimTextLabel))Do
      Begin
        AutoSize := True;
        Text := 'note';
        AutoSize := False;
      End;
      FInNote := TMimInput( CreateDetail( 125, 30, 'InNote', TMimInput));

      With TMimTextLabel( CreateDetail( 152, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := 'gate';
        AutoSize := False;
      End;
      FInGate := TMimInput( CreateDetail( 155, 30, 'InGate', TMimInput));
      With FInGate Do
      Begin
        ConnectorType := ctLogic;
        Value         := 0;
      End;

      With TMimTextLabel( CreateDetail( 185, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := 'vel';
        AutoSize := False;
      End;
      FInVel := TMimInput( CreateDetail( 185, 30, 'InVel', TMimInput));

      With TMimTextLabel( CreateDetail( 207, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := 'rel vel';
        AutoSize := False;
      End;
      FInVelOff := TMimInput( CreateDetail( 215, 30, 'InVelOff', TMimInput));

      FIndicator := TMimLed( CreateDetail( 159, 5, '', TMimLed));

      V := TMimViewer( CreateDetail( 91, 30, '', TMimViewer));
      V.Width := V.Width - 15;
      FKnobCh := TMimKnob( CreateDetail( 60, 18, '', TMimKnob));
      With FKnobCh Do
      Begin
        Viewer        := V;
        MinValue      := 1;
        MaxValue      := 16;
        Step          := 1;
        Value         := 1;
        OnValueChange := KnobChValueChanged;
        FChannel      := Value - 1;
      End;
      With TMimTextLabel( CreateDetail( 95, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := 'Ch';
        AutoSize := False;
      End;

      FInCh := TMimInput( CreateDetail( 8, 30, 'InCh', TMimInput));
      With FInCh Do
      Begin
        ConnectorType := ctAsymmetric;
        Value         := 0;
      End;
      With TMimTextLabel( CreateDetail( 10, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'ch';
        AutoSize := False;
      End;

      FButtonGate := TMimPushButton( CreateDetail( 30, 20, '', TMimPushButton));
      With FButtonGate Do
      Begin
        LoadBitmap( 'Square.bmp');
        AllowAllUp    := True;
        OnValueChange := ButtonGateChanged;
        Down          := False;
      End;
      FGateActive := FButtonGate.Down;

      FOldNote := -1;
    End;

//  Public

    Procedure   TMimMidiOut.Execute; // Override;
    Var
      aGateValue : TMimValue;
      aNoteValue : TMimValue;
      aVelValue  : TMimValue;
      aVelOffVal : TMimValue;
      aChVal     : TMimValue;
    Begin

      aNoteValue  := FInNote.Value Div 8;
      Clip( aNoteValue, 0, 127);

      aGateValue  := FInGate.Value;

      If FInVel.Connected
      Then aVelValue := FInVel.Value Div 8
      Else aVelValue := 127;
      Clip( aVelValue , 0, 127);

      If FInVelOff.Connected
      Then aVelOffVal := FInVelOff.Value Div 8
      Else aVelOffVal := 127;
      Clip( aVelOffVal, 0, 127);

      If FInCh.Connected
      Then aChVal := FInCh.Value
      Else aChVal := FChannel;
      Clip( aChVal, 0,  15);

      FPrevChVal := aChVal;

      If FGateActive
      Then Begin
        If ( aGateValue > 0)
        Then Begin
          If FOldNote <> aNoteValue
          Then Begin
            If FOldNote >= 0
            Then MidiOutShort( AssembleShortMidi( aChVal, CNoteOff , FOldNote, aVelOffVal));
            MidiOutShort( AssembleShortMidi( aChVal, CNoteOn , aNoteValue, aVelValue));
            FOldNote := aNoteValue;
          End;
        End
        Else If FOldNote >= 0
        Then Begin
          MidiOutShort( AssembleShortMidi( aChVal, CNoteOff , FOldNote, aVelOffVal));
          FOldNote := -1;
        End;
      End
      //////////////////////////////////////////////////////////////////////////
      Else Begin
        If ( FOldGate <= 0) And ( aGateValue > 0)
        Then Begin
          // Must turn a note on, but turn off the old note first.
          If FOldNote >= 0
          Then Begin
            MidiOutShort( AssembleShortMidi( aChVal, CNoteOff , FOldNote, aVelOffVal));
            FOldNote := -1;
          End;
          If aNoteValue >= 0
          Then Begin
            MidiOutShort( AssembleShortMidi( aChVal, CNoteOn , aNoteValue, aVelValue));
            FOldNote := aNoteValue;
          End;
        End
        Else If ( FOldGate > 0) And ( aGateValue <= 0)
        Then Begin
          // Must turn a note off
          If FOldNote >= 0
          Then Begin
            MidiOutShort( AssembleShortMidi( aChVal, CNoteOff , FOldNote, aVelOffVal));
            FOldNote := -1;
          End;
        End;
      End;
      FOldGate := aGateValue;

      FIndicator.Active := aGateValue > 0;
    End;


{ ========
  TControlIn = Class( TMidiModule)
  Private
      FOut     : TOutput;
      FKnobCh  : TKnob;
      FKnobCtr : TKnob;
      FInd     : TIndicator;
      FCh      : Integer;
      FCtr     : Integer;
  Published
    Property    KnobChValue  : Integer Read GetKnobChValue  Write SetKnobChValue;
    Property    KnobCtrValue : Integer Read GetKnobCtrValue Write SetKnobCtrValue;
  Private
}

    procedure   TMimControlIn.KnobChValueChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FCh := aValue - 1;
    End;

    Procedure   TMimControlIn.KnobCtrValueChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FCtr := aValue;
    End;

    Function    TMimControlIn.GetKnobChValue: TMimValue;
    Begin
      Result := FKnobCh.Value;
    End;

    Procedure   TMimControlIn.SetKnobChValue( aValue: TMimValue);
    Begin
      FKnobCh.Value := aValue;
    End;

    Function    TMimControlIn.GetKnobCtrValue: TMimValue;
    Begin
      Result := FKnobCtr.Value;
    End;

    Procedure   TMimControlIn.SetKnobCtrValue( aValue: TMimValue);
    Begin
      FKnobCtr.Value := aValue;
    End;

//  Protected

    Procedure   TMimControlIn.CreateDetails; // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;
      FOut := TMimOutput( CreateDetail( Width - 23, 30, 'Out', TMimOutput));
      With FOut Do
      Begin
        ConnectorType := ctAsymmetric;
        Value         := 0;
      End;
      FInd := TMimLed( CreateDetail( Width - 20, 20, '', TMimLed));

      V := TMimViewer( CreateDetail( 108, 30, '', TMimViewer));
      V.Width := V.Width - 15;
      FKnobCh := TMimKnob( CreateDetail( 77, 18, '', TMimKnob));
      With FKnobCh Do
      Begin
        Viewer        := V;
        OnValueChange := KnobChValueChanged;
        MinValue      := 1;
        MaxValue      := 16;
        Step          := 1;
        Value         := 1;
        FCh           := Value - 1;
      End;
      With TMimTextLabel( CreateDetail( 110, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'Ch';
        AutoSize := False;
      End;
      V := TMimViewer( CreateDetail( 190, 30, '', TMimViewer));
      V.Width := V.Width - 2;
      FKnobCtr := TMimKnob( CreateDetail( 159, 18, '', TMimKnob));
      With FKnobCtr Do
      Begin
        Viewer        := V;
        OnValueChange := KnobCtrValueChanged;
        MinValue      := 0;
        MaxValue      := 120;
        Step          := 1;
        Value         := 2;
        FCtr          := Value;
      End;
      With TMimTextLabel( CreateDetail( 192, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'Ctr';
        AutoSize := False;
      End;
    End;

    Procedure   TMimControlIn.AcceptMidiShort( aShortMidi: TShortMidi); // Override;
    Var
      aCh    : Byte;
      aMsg   : Byte;
      aData1 : Byte;
      aData2 : Byte;
    Begin
      DisassembleShortMidi( aShortMidi, aCh, aMsg, aData1, aData2);
      If
        ( aMsg   = CControlChange) And
        ( aCh    = FCh           ) And
        ( aData1 = FCtr          )
      Then Begin
        FOut.Value := 8 * aData2;
        With FInd Do Active := Not Active;
      End;
    End;


{ ========
  TControlOut = Class( TMidiModule)
  Private
      FIn        : TInput;
      FKnobCh    : TKnob;
      FKnobCtr   : TKnob;
      FCh        : Integer;
      FCtr       : Integer;
      FPrevValue : Integer;
      FPrevChVal : Integer;
      FPrevCtrVal: Integer;
  Published
    Property    KnobChValue  : Integer Read GetKnobChValue  Write SetKnobChValue;
    Property    KnobCtrValue : Integer Read GetKnobCtrValue Write SetKnobCtrValue;
  Private
}

    procedure   TMimControlOut.KnobChValueChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FChannel := aValue - 1;
    End;

    Procedure   TMimControlOut.KnobCtrValueChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FCtr := aValue;
    End;

    Function    TMimControlOut.GetKnobChValue: TMimValue;
    Begin
      Result := FKnobCh.Value;
    End;

    Procedure   TMimControlOut.SetKnobChValue( aValue: TMimValue);
    Begin
      FKnobCh.Value := aValue;
    End;

    Function    TMimControlOut.GetKnobCtrValue: TMimValue;
    Begin
      Result := FKnobCtr.Value;
    End;

    Procedure   TMimControlOut.SetKnobCtrValue( aValue: TMimValue);
    Begin
      FKnobCtr.Value := aValue;
    End;

//  Protected

    Procedure   TMimControlOut.CreateDetails; // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;

      FPrevValue  := 0;
      FPrevChVal  := 0;
      FPrevCtrVal := 0;

      FInCh := TMimInput( CreateDetail( 10, 30, 'InCh', TMimInput));
      With FInCh Do
      Begin
        ConnectorType := ctAsymmetric;
        Value         := 0;
      End;
      With TMimTextLabel( CreateDetail( 12, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'ch';
        AutoSize := False;
      End;


      FInCtr := TMimInput( CreateDetail( 30, 30, 'InCtr', TMimInput));
      With FInCtr Do
      Begin
        ConnectorType := ctAsymmetric;
        Value         := 0;
      End;
      With TMimTextLabel( CreateDetail( 31, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'ctr';
        AutoSize := False;
      End;

      FIn := TMimInput( CreateDetail( 50, 30, 'In', TMimInput));
      With FIn Do
      Begin
        ConnectorType := ctAsymmetric;
        Value         := 0;
      End;
      With TMimTextLabel( CreateDetail( 52, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'in';
        AutoSize := False;
      End;


      V := TMimViewer( CreateDetail( 118, 30, '', TMimViewer));
      V.Width := V.Width - 15;
      FKnobCh := TMimKnob( CreateDetail( 87, 18, '', TMimKnob));
      With FKnobCh Do
      Begin
        Viewer        := V;
        OnValueChange := KnobChValueChanged;
        MinValue      := 1;
        MaxValue      := 16;
        Step          := 1;
        Value         := 1;
        FChannel      := Value - 1;
      End;
      With TMimTextLabel( CreateDetail( 120, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'Ch';
        AutoSize := False;
      End;
      
      V := TMimViewer( CreateDetail( 190, 30, '', TMimViewer));
      V.Width := V.Width - 2;
      FKnobCtr := TMimKnob( CreateDetail( 159, 18, '', TMimKnob));
      With FKnobCtr Do
      Begin
        Viewer        := V;
        OnValueChange := KnobCtrValueChanged;
        MinValue      := 0;
        MaxValue      := 120;
        Step          := 1;
        Value         := 2;
        FCtr          := Value;
      End;
      With TMimTextLabel( CreateDetail( 192, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'Ctr';
        AutoSize := False;
      End;

    End;

//  Public

    Procedure   TMimControlOut.Execute; // Override;
    Var
      aValue  : TMimValue;
      aChVal  : TMimValue;
      aCtrVal : TMimValue;
      Changed : Boolean;
    Begin
      Changed := False;

      aValue  := FIn.Value Div 8;
      Clip( aValue , 0, 127);
      If aValue <> FPrevValue
      Then Begin
        FPrevValue := aValue;
        Changed    := True;
      End;

      If FInCh.Connected
      Then aChVal := FinCh.Value
      Else aChVal := FChannel;
      Clip( aChVal , 0,  15);
      If aChVal <> FPrevChVal
      Then Begin
        FPrevChVal := aChVal;
        Changed    := True;
      End;


      If FInCtr.Connected
      Then aCtrVal := FinCtr.Value
      Else aCtrVal := FKnobCtr.Value;
      Clip( aCtrVal, 0, 120);
      If aCtrVal <> FPrevCtrVal
      Then
      Begin
        FPrevCtrVal := aCtrVal;
        Changed     := True;
      End;

      If Changed
      Then
        MidiOutShort(
          AssembleShortMidi(
            aChVal,
            CControlChange,
            aCtrVal,
            aValue
          )
        );
    End;


{ ========
  TBendIn = Class( TMidiModule)
  Private
      FOut       : TOutput;
      FKnobCh    : TKnob;
      FKnobSense : TKnob;
      FInd       : TIndicator;
      FCh        : Integer;
      FSense     : TValue;
      FIndCount  : Integer;
  Published
    Property    KnobChValue    : Integer Read GetKnobChValue    Write SetKnobChValue;
    Property    KnobSenseValue : Integer Read GetKnobSenseValue Write SetKnobSenseValue;
  Private
}

    procedure   TMimBendIn.KnobChValueChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FCh := aValue - 1;
    End;

    Procedure   TMimBendIn.KnobSenseValueChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FSense := aValue;
    End;

    Function    TMimBendIn.GetKnobChValue: TMimValue;
    Begin
      Result := FKnobCh.Value;
    End;

    Procedure   TMimBendIn.SetKnobChValue( aValue: TMimValue);
    Begin
      FKnobCh.Value := aValue;
    End;

    Function    TMimBendIn.GetKnobSenseValue: TMimValue;
    Begin
      Result := FKnobSense.Value;
    End;

    Procedure   TMimBendIn.SetKnobSenseValue( aValue: TMimValue);
    Begin
      FKnobSense.Value := aValue;
    End;

//  Protected

    Procedure   TMimBendIn.CreateDetails; // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;
      FOut := TMimOutput( CreateDetail( Width - 23, 30, 'Out', TMimOutput));
      With FOut Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;
      FInd := TMimLed( CreateDetail( Width - 20, 20, '', TMimLed));

      V := TMimViewer( CreateDetail( 108, 30, '', TMimViewer));
      V.Width := V.Width - 15;
      FKnobCh := TMimKnob( CreateDetail( 77, 18, '', TMimKnob));
      With FKnobCh Do
      Begin
        Viewer        := V;
        OnValueChange := KnobChValueChanged;
        MinValue      := 1;
        MaxValue      := 16;
        Step          := 1;
        Value         := 1;
        FCh           := Value - 1;
      End;
      With TMimTextLabel( CreateDetail( 110, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'Ch';
        AutoSize := False;
      End;
      V := TMimViewer( CreateDetail( 190, 30, '', TMimViewer));
      V.Width := V.Width - 2;
      FKnobSense := TMimKnob( CreateDetail( 159, 18, '', TMimKnob));
      With FKnobSense Do
      Begin
        Viewer        := V;
        OnValueChange := KnobSenseValueChanged;
        MinValue      := 0;
        MaxValue      := 1000;
        Step          := 1000 Div 250;
        Value         := 1000;
        FSense        := Value;
      End;
      With TMimTextLabel( CreateDetail( 192, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'Sense';
        AutoSize := False;
      End;
    End;

    Procedure   TMimBendIn.AcceptMidiShort( aShortMidi: TShortMidi); // Override;
    Var
      aCh    : Byte;
      aMsg   : Byte;
      aData1 : Byte;
      aData2 : Byte;
      aBend  : Integer;
    Begin
      DisassembleShortMidi( aShortMidi, aCh, aMsg, aData1, aData2);
      If
        ( aMsg = CPitchBend) And
        ( aCh  = FCh       )
      Then Begin
        aBend := Round( - 1000 + 2000 * ( aData1 + 128 * aData2) / 16383);
        FOut.Value := aBend;
        Inc( FIndCount);
        If ( FIndCount < 0) Or ( FIndCount > 40)
        Then Begin
          FIndCount := 0;
          With FInd Do Active := Not Active;
        End;
      End;
    End;


{ ========
  TBendOut = Class( TMidiModule)
  Private
      FIn           : TInput;
      FKnobCh       : TKnob;
      FKnobSense    : TKnob;
      FCh           : Integer;
      FSense        : TValue;
      FPrevValue    : Integer;
      FPrevChVal    : Integer;
      FPrevSenseVal : Integer;
  Published
    Property    KnobChValue    : Integer Read GetKnobChValue    Write SetKnobChValue;
    Property    KnobSenseValue : Integer Read GetKnobSenseValue Write SetKnobSenseValue;
  Private
}

    procedure   TMimBendOut.KnobChValueChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FChannel := aValue - 1;
    End;

    Procedure   TMimBendOut.KnobSenseValueChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FSense := aValue;
    End;

    Function    TMimBendOut.GetKnobChValue: TMimValue;
    Begin
      Result := FKnobCh.Value;
    End;

    Procedure   TMimBendOut.SetKnobChValue( aValue: TMimValue);
    Begin
      FKnobCh.Value := aValue;
    End;

    Function    TMimBendOut.GetKnobSenseValue: TMimValue;
    Begin
      Result := FKnobSense.Value;
    End;

    Procedure   TMimBendOut.SetKnobSenseValue( aValue: TMimValue);
    Begin
      FKnobSense.Value := aValue;
    End;

//  Protected

    Procedure   TMimBendOut.CreateDetails; // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;

      FPrevValue    := 0;
      FPrevChVal    := 0;
      FPrevSenseVal := 0;

      FInCh := TMimInput( CreateDetail( 10, 30, 'InCh', TMimInput));
      With FInCh Do
      Begin
        ConnectorType := ctAsymmetric;
        Value         := 0;
      End;
      With TMimTextLabel( CreateDetail( 12, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'ch';
        AutoSize := False;
      End;

      FInSense := TMimInput( CreateDetail( 30, 30, 'InSense', TMimInput));
      With FInSense Do
      Begin
        ConnectorType := ctAsymmetric;
        Value         := 0;
      End;
      With TMimTextLabel( CreateDetail( 25, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'sense';
        AutoSize := False;
      End;

      FIn := TMimInput( CreateDetail( 50, 30, 'In', TMimInput));
      With FIn Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;
      With TMimTextLabel( CreateDetail( 53, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'in';
        AutoSize := False;
      End;

      V := TMimViewer( CreateDetail( 118, 30, '', TMimViewer));
      V.Width := V.Width - 15;
      FKnobCh := TMimKnob( CreateDetail( 87, 18, '', TMimKnob));
      With FKnobCh Do
      Begin
        Viewer        := V;
        OnValueChange := KnobChValueChanged;
        MinValue      := 1;
        MaxValue      := 16;
        Step          := 1;
        Value         := 1;
        FChannel      := Value - 1;
      End;
      With TMimTextLabel( CreateDetail( 120, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'Ch';
        AutoSize := False;
      End;

      V := TMimViewer( CreateDetail( 190, 30, '', TMimViewer));
      V.Width := V.Width - 2;
      FKnobSense := TMimKnob( CreateDetail( 159, 18, '', TMimKnob));
      With FKnobSense Do
      Begin
        Viewer        := V;
        OnValueChange := KnobSenseValueChanged;
        MinValue      := 0;
        MaxValue      := 1000;
        Step          := 1000 Div 250;
        Value         := 1000;
        FSense        := Value;
      End;
      With TMimTextLabel( CreateDetail( 192, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'Sense';
        AutoSize := False;
      End;

    End;

//  Public

    Procedure   TMimBendOut.Execute; // Override;
    Var
      aValue    : Integer;
      aChVal    : Integer;
      aSenseVal : TMimValue;
      Changed   : Boolean;
    Begin
      Changed := False;

      If FInCh.Connected
      Then aChVal := FinCh.Value
      Else aChVal := FChannel;
      Clip( aChVal, 0, 15);
      If aChVal <> FPrevChVal
      Then Begin
        FPrevChVal := aChVal;
        Changed    := True;
      End;

      If FInSense.Connected
      Then aSenseVal := Round( FinSense.Value * FSense / 1000)
      Else aSenseVal := FSense;

      aValue := Round( 16383 * (( FIn.Value + 1000) / 2000) * aSenseVal / 1000);
      Clip( aValue, 0, 16383);
      If aValue <> FPrevValue
      Then Begin
        FPrevValue := aValue;
        Changed    := True;
      End;

      If Changed
      Then
        MidiOutShort(
          AssembleShortMidi(
            aChVal,
            CPitchBend,
            aValue And $7f,
            ( aValue Shr 7) And $7f
          )
        );
    End;


{ ========
  TDividerFixed = Class( TModule)
  Private
      FIn        : TInput;
      FOut1      : Toutput;
      FOut2      : Toutput;
      FOut4      : Toutput;
      FOut8      : Toutput;
      FOut16     : Toutput;
      FOut32     : Toutput;
      FOut64     : Toutput;
      FOut128    : Toutput;
      FOut256    : Toutput;
      FOut512    : Toutput;
      FOut1024   : Toutput;
      FInd1      : TIndicator;
      FInd2      : TIndicator;
      FInd4      : TIndicator;
      Find8      : TIndicator;
      FInK36     : TIndicator;
      FInd32     : TIndicator;
      FInd64     : TIndicator;
      FInK328    : TIndicator;
      FInd128    : TIndicator;
      FInd512    : TIndicator;
      FInd1024   : TIndicator;
      FCounter   : Integer;
      FPrevValue : Integer;
  Protected
}

    Procedure   TMimDividerFixed.CreateDetails; // Override;
    Begin
      Inherited CreateDetails;
      FCounter   := 0;
      FPrevValue := 0;
      FIn      := TMimInput    ( CreateDetail(   8, 30, 'In'     , TMimInput    ));
      FOut1    := TMimOutput   ( CreateDetail(  28, 30, 'Out1'   , TMimOutput   ));
      FOut2    := TMimOutput   ( CreateDetail(  48, 30, 'Out2'   , TMimOutput   ));
      FOut4    := TMimOutput   ( CreateDetail(  68, 30, 'Out4'   , TMimOutput   ));
      FOut8    := TMimOutput   ( CreateDetail(  88, 30, 'Out8'   , TMimOutput   ));
      FOut16   := TMimOutput   ( CreateDetail( 108, 30, 'Out16'  , TMimOutput   ));
      FOut32   := TMimOutput   ( CreateDetail( 128, 30, 'Out32'  , TMimOutput   ));
      FOut64   := TMimOutput   ( CreateDetail( 148, 30, 'Out64'  , TMimOutput   ));
      FOut128  := TMimOutput   ( CreateDetail( 168, 30, 'Out128' , TMimOutput   ));
      FOut256  := TMimOutput   ( CreateDetail( 188, 30, 'Out256' , TMimOutput   ));
      FOut512  := TMimOutput   ( CreateDetail( 208, 30, 'Out512' , TMimOutput   ));
      FOut1024 := TMimOutput   ( CreateDetail( 228, 30, 'Out1024', TMimOutput   ));
      Find1    := TMimLed( CreateDetail(  31, 20, ''       , TMimLed));
      Find2    := TMimLed( CreateDetail(  51, 20, ''       , TMimLed));
      FInd4    := TMimLed( CreateDetail(  71, 20, ''       , TMimLed));
      Find8    := TMimLed( CreateDetail(  91, 20, ''       , TMimLed));
      Find16   := TMimLed( CreateDetail( 111, 20, ''       , TMimLed));
      FInd32   := TMimLed( CreateDetail( 131, 20, ''       , TMimLed));
      FInd64   := TMimLed( CreateDetail( 151, 20, ''       , TMimLed));
      Find128  := TMimLed( CreateDetail( 171, 20, ''       , TMimLed));
      Find256  := TMimLed( CreateDetail( 191, 20, ''       , TMimLed));
      FInd512  := TMimLed( CreateDetail( 211, 20, ''       , TMimLed));
      Find1024 := TMimLed( CreateDetail( 231, 20, ''       , TMimLed));
      FIn     .ConnectorType := ctLogic;
      FOut1   .ConnectorType := ctLogic;
      FOut2   .ConnectorType := ctLogic;
      FOut4   .ConnectorType := ctLogic;
      FOut8   .ConnectorType := ctLogic;
      FOut16  .ConnectorType := ctLogic;
      FOut32  .ConnectorType := ctLogic;
      FOut64  .ConnectorType := ctLogic;
      FOut128 .ConnectorType := ctLogic;
      FOut256 .ConnectorType := ctLogic;
      FOut512 .ConnectorType := ctLogic;
      FOut1024.ConnectorType := ctLogic;
      With TMimTextLabel( CreateDetail( 10, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'in';
        AutoSize := False;
      End;

    End;

//   Public

    Procedure   TMimDividerFixed.Execute; // Override;
    Var
      aNewValue : TMimValue;
    Begin
      aNewValue := FIn.Value;
      If ( FPrevValue <= 0) And ( aNewValue > 0)
      Then Begin
        Inc( FCounter);
        If FCounter > 65535 // that will do ...
        Then FCounter := 0;

        If FCounter And 1 = 0
        Then FOut1.Value := 0
        Else FOut1.Value := UnityValue;
        Find1.Active := FOut1.Value > 0;

        If FCounter And 2 = 0
        Then FOut2.Value := 0
        Else FOut2.Value := UnityValue;
        Find2.Active := FOut2.Value > 0;

        If FCounter And 4 = 0
        Then FOut4.Value := 0
        Else FOut4.Value := UnityValue;
        FInd4.Active := FOut4.Value > 0;

        If FCounter And 8 = 0
        Then FOut8.Value := 0
        Else FOut8.Value := UnityValue;
        FInd8.Active := FOut8.Value > 0;

        If FCounter And 16 = 0
        Then FOut16.Value := 0
        Else FOut16.Value := UnityValue;
        Find16.Active := FOut16.Value > 0;

        If FCounter And 32 = 0
        Then FOut32.Value := 0
        Else FOut32.Value := UnityValue;
        FInd32.Active := FOut32.Value > 0;

        If FCounter And 64 = 0
        Then FOut64.Value := 0
        Else FOut64.Value := UnityValue;
        FInd64.Active := FOut64.Value > 0;

        If FCounter And 128 = 0
        Then FOut128.Value := 0
        Else FOut128.Value := UnityValue;
        Find128.Active := FOut128.Value > 0;

        If FCounter And 256 = 0
        Then FOut256.Value := 0
        Else FOut256.Value := UnityValue;
        Find256.Active := FOut256.Value > 0;

        If FCounter And 512 = 0
        Then FOut512.Value := 0
        Else FOut512.Value := UnityValue;
        FInd512.Active := FOut512.Value > 0;

        If FCounter And 1024 = 0
        Then FOut1024.Value := 0
        Else FOut1024.Value := UnityValue;
        Find1024.Active := FOut1024.Value > 0;
      End;
      FPrevValue := aNewValue;
    End;


{ ========
  TFreqDivider = Class( TModule)
  Private
      FInp       : TInput;
      FOutp      : TOutput;
      FKnob      : TKnob;
      FIndicator : TIndicator;
      FDivisor   : Integer;
      FCounter   : Integer;
      FPrevValue : Integer;
  Published
    Property    KnobValue: Integer Read GEtKnobValue Write SetKnobValue;
  Private
}

    Procedure   TMimFreqDivider.KnobValueChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FDivisor := aValue - 1;
      If FCounter > FDivisor
      Then FCounter := FDivisor;
    End;

    Function    TMimFreqDivider.GetKnobValue: TMimValue;
    Begin
      Result := FKnob.Value;
    End;

    Procedure   TMimFreqDivider.SetKnobValue( aValue: TMimValue);
    Begin
      FKnob.Value := aValue;
    End;

//  Protected

    Procedure   TMimFreqDivider.CreateDetails; // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;
      FDivisor   := 1;
      FCounter   := 1;
      FPrevValue := 0;

      FOutp := TMimOutput( CreateDetail( Width - 23, 30, 'Outp', TMimOutput));
      With FOutp Do
      Begin
        ConnectorType := ctLogic;
        Value         := 0;
      End;

      FInp := TMimInput( CreateDetail( 8, 30, 'Inp', TMimInput));
      With FInp Do
      Begin
        ConnectorType := ctLogic;
        Value         := 0;
      End;
      With TMimTextLabel( CreateDetail( 10, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'in';
        AutoSize := False;
      End;


      FSync := TMimInput( CreateDetail( 30, 30, 'Sync', TMimInput));
      With FSync Do
      Begin Begin
        ConnectorType := ctLogic;
        Value         := 0;
      End;
      End;
      With TMimTextLabel( CreateDetail( 30, 14, '', TMimTextLabel)) Do
      Begin
        AutoSize    := True;
        Text        := 'snc';
        AutoSize    := False;
        ParentColor := False;
        TextColor   := clBlack;
      End;

      V := TMimViewer( CreateDetail( 190,  2, '', TMimViewer));
      V.Width := V.Width - 2;
      FKnob := TMimKnob( CreateDetail( 193, 18, '', TMimKnob));
      With FKnob Do
      Begin
        Viewer        := V;
        MinValue      := 2;
        MaxValue      := 256;
        Step          := 1;
        Value         := 2;
        OnValueChange := KnobValueChanged;
        FDivisor      := Value - 1;
      End;

      FIndicator := TMimLed( CreateDetail( Width - 20, 20, '', TMimLed));
    End;

//  Public

    Procedure   TMimFreqDivider.Execute; // Override;
    Var
      aValue : TMimValue;
    Begin
      aValue := FSync.Value;
      If ( aValue > 0) And ( FPrevSync <= 0)
      Then FCounter := FDivisor;
      FPrevSync := aValue;

      aValue := FInp.Value;
      If ( aValue > 0) And ( FPrevValue <= 0)
      Then Begin
        If FCounter > FDivisor
        Then FCounter := FDivisor;
        Dec( FCounter);
        If FCounter <= 0
        Then Begin
          If FOutp.Value > 0
          Then FOutp.Value := 0
          Else Foutp.Value := UnityValue;
          FIndicator.Active := FOutp.Value > 0;
          FCounter := FDivisor;
        End;
      End;
      FPrevValue := aValue;
    End;


{ ========
  TTable = Class( TModule)
  Private
      FK1       : TKnob;
      FK2       : TKnob;
      FK3       : TKnob;
      FK4       : TKnob;
      FK5       : TKnob;
      FK6       : TKnob;
      FK7       : TKnob;
      FK8       : TKnob;
      FI1       : TIndicator;
      FI2       : TIndicator;
      FI3       : TIndicator;
      FI4       : TIndicator;
      FI5       : TIndicator;
      FI6       : TIndicator;
      FI7       : TIndicator;
      FI8       : TIndicator;
      FInp      : TInput;
      Foutp     : TOutput;
      FChain    : TOutput;
      FSV       : TKnob;
      FButMode  : TPushButton;
      FValues   : Array[ 1 .. 8] Of TValue;
      FStartVal : TValue;
      FViewMode : Integer;
  Published
    Property    K1          : Integer Read GetK1          Write SetK1;
    Property    K2          : Integer Read GetK2          Write SetK2;
    Property    K3          : Integer Read GetK3          Write SetK3;
    Property    K4          : Integer Read GetK4          Write SetK4;
    Property    K5          : Integer Read GetK5          Write SetK5;
    Property    K6          : Integer Read GetK6          Write SetK6;
    Property    K7          : Integer Read GetK7          Write SetK7;
    Property    K8          : Integer Read GetK8          Write SetK8;
    Property    SV          : Integer Read GetSV          Write SetSV;
    Property    ButModeDown : Boolean Read GetButModeDown Write SetButModeDown;
  Private
}

    Procedure   TMimTable.KValueChanged( aSender: TObject; aValue: TMimValue);
    Begin
      With aSender As TMimKnob Do
      Begin
        If FValues[ Tag] <> aValue
        Then Begin
          FValues[ Tag] := aValue;
          If Viewer <> Nil
          Then
            Case FViewMode Of
              0 : Viewer.Text := IntToStr( aValue);
              1 : Viewer.Text := IntegerToNoteStr( aValue Div 8); 
            End;
        End;
      End;
    End;

    Procedure   TMimTable.StartValChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FStartVal := aValue;
    End;

    Procedure   TMimTable.ButModeValueChanged( aSender: TObject; aValue: Boolean);
    Begin
      FViewMode := Ord( aValue);
      SetKValue( FK1, FK1.Value);
      SetKValue( FK2, FK2.Value);
      SetKValue( FK3, FK3.Value);
      SetKValue( FK4, FK4.Value);
      SetKValue( FK5, FK5.Value);
      SetKValue( FK6, FK6.Value);
      SetKValue( FK7, FK7.Value);
      SetKValue( FK8, FK8.Value);
    End;

    Procedure   TMimTable.SetKValue( aK: TMimKnob; aValue: TMimValue);
    Begin
      With aK Do
      Begin
        Value := aValue;
        If Viewer <> Nil
        Then
          Case FViewMode Of
            0 : Viewer.Text := IntToStr( aValue);
            1 : Viewer.Text := IntegerToNoteStr( aValue Div 8);
          End;
      End;
    End;

    Procedure   TMimTable.SetK1( aValue: TMimValue);
    Begin
      SetKValue( FK1, aValue);
    End;

    Procedure   TMimTable.SetK2( aValue: TMimValue);
    Begin
      SetKValue( FK2, aValue);
    End;

    Procedure   TMimTable.SetK3( aValue: TMimValue);
    Begin
      SetKValue( FK3, aValue);
    End;

    Procedure   TMimTable.SetK4( aValue: TMimValue);
    Begin
      SetKValue( FK4, aValue);
    End;

    Procedure   TMimTable.SetK5( aValue: TMimValue);
    Begin
      SetKValue( FK5, aValue);
    End;

    Procedure   TMimTable.SetK6( aValue: TMimValue);
    Begin
      SetKValue( FK6, aValue);
    End;

    Procedure   TMimTable.SetK7( aValue: TMimValue);
    Begin
      SetKValue( FK7, aValue);
    End;

    Procedure   TMimTable.SetK8( aValue: TMimValue);
    Begin
      SetKValue( FK8, aValue);
    End;

    Procedure   TMimTable.SetSV( aValue: TMimValue);
    Begin
      FSV.Value := aValue;
    End;

    ////////////////////////////////////////////////////////

    Function    TMimTable.GetK1: TMimValue;
    Begin
      Result := FK1.Value;
    End;

    Function    TMimTable.GetK2: TMimValue;
    Begin
      Result := FK2.Value;
    End;

    Function    TMimTable.GetK3: TMimValue;
    Begin
      Result := FK3.Value;
    End;

    Function    TMimTable.GetK4: TMimValue;
    Begin
      Result := FK4.Value;
    End;

    Function    TMimTable.GetK5: TMimValue;
    Begin
      Result := FK5.Value;
    End;

    Function    TMimTable.GetK6: TMimValue;
    Begin
      Result := FK6.Value;
    End;

    Function    TMimTable.GetK7: TMimValue;
    Begin
      Result := FK7.Value;
    End;

    Function    TMimTable.GetK8: TMimValue;
    Begin
      Result := FK8.Value;
    End;

    Function    TMimTable.GetSV: TMimValue;
    Begin
      Result := FSV.Value;
    End;

    Function    TMimTable.GetButModeDown: Boolean;
    Begin
      Result := FButMode.Down;
    End;

    Procedure   TMimTable.SetButModeDown( aValue: Boolean);
    Begin
      FButMode.Down := aValue;
    End;

//  Protected

    Procedure   TMimTable.CreateDetails; // Override;
    Var
      i : Integer;
      V : TMimViewer;
    Begin
      Inherited CreateDetails;
      Height := Height * 2;

      For i := 1 To 8 Do
        FValues[ i] := 0;

      V := TMimViewer( CreateDetail( 3, 28, '', TMimViewer));
      V.Width := V.Width - 5;
      FK1 := TMimKnob( CreateDetail( 5, 44, '', TMimKnob));
      With FK1 Do
      Begin
        Viewer        := V;
        Tag           := 1;
        OnValueChange := KValueChanged;
        MinValue      := -1000;
        MaxValue      := 1000;
        Step          := 1000 Div 250;
        Value         := 60 * 8;
      End;

      V := TMimViewer( CreateDetail( 33, 28, '', TMimViewer));
      V.Width := V.Width - 5;
      FK2 := TMimKnob( CreateDetail( 35, 44, '', TMimKnob));
      With FK2 Do
      Begin
        Viewer        := V;
        Tag           := 2;
        OnValueChange := KValueChanged;
        MinValue      := -1000;
        MaxValue      := 1000;
        Step          := 1000 Div 250;
        Value         := 60 * 8;
      End;

      V := TMimViewer( CreateDetail( 63, 28, '', TMimViewer));
      V.Width := V.Width - 5;
      FK3 := TMimKnob( CreateDetail( 65, 44, '', TMimKnob));
      With FK3 Do
      Begin
        Viewer        := V;
        Tag           := 3;
        OnValueChange := KValueChanged;
        MinValue      := -1000;
        MaxValue      := 1000;
        Step          := 1000 Div 250;
        Value         := 60 * 8;
      End;

      V := TMimViewer( CreateDetail( 93, 28, '', TMimViewer));
      V.Width := V.Width - 5;
      FK4 := TMimKnob( CreateDetail( 95, 44, '', TMimKnob));
      With FK4 Do
      Begin
        Viewer        := V;
        Tag           := 4;
        OnValueChange := KValueChanged;
        MinValue      := -1000;
        MaxValue      := 1000;
        Step          := 1000 Div 250;
        Value         := 60 * 8;
      End;

      V := TMimViewer( CreateDetail( 123, 28, '', TMimViewer));
      V.Width := V.Width - 5;
      FK5 := TMimKnob( CreateDetail( 125, 44, '', TMimKnob));
      With FK5 Do
      Begin
        Viewer        := V;
        Tag           := 5;
        OnValueChange := KValueChanged;
        MinValue      := -1000;
        MaxValue      := 1000;
        Step          := 1000 Div 250;
        Value         := 60 * 8;
      End;

      V := TMimViewer( CreateDetail( 153, 28, '', TMimViewer));
      V.Width := V.Width - 5;
      FK6 := TMimKnob( CreateDetail( 155, 44, '', TMimKnob));
      With FK6 Do
      Begin
        Viewer        := V;
        Tag           := 6;
        OnValueChange := KValueChanged;
        MinValue      := -1000;
        MaxValue      := 1000;
        Step          := 1000 Div 250;
        Value         := 60 * 8;
      End;

      V := TMimViewer( CreateDetail( 183, 28, '', TMimViewer));
      V.Width := V.Width - 5;
      FK7 := TMimKnob( CreateDetail( 185, 44, '', TMimKnob));
      With FK7 Do
      Begin
        Viewer        := V;
        Tag           := 7;
        OnValueChange := KValueChanged;
        MinValue      := -1000;
        MaxValue      := 1000;
        Step          := 1000 Div 250;
        Value         := 60 * 8;
      End;

      V := TMimViewer( CreateDetail( 213, 28, '', TMimViewer));
      V.Width := V.Width - 5;
      FK8 := TMimKnob( CreateDetail( 215, 44, '', TMimKnob));
      With FK8 Do
      Begin
        Viewer        := V;
        Tag           := 8;
        OnValueChange := KValueChanged;
        MinValue      := -1000;
        MaxValue      := 1000;
        Step          := 1000 Div 250;
        Value         := 60 * 8;
      End;

      FI1 := TMimLed( CreateDetail(  13, 20, '', TMimLed));
      FI2 := TMimLed( CreateDetail(  43, 20, '', TMimLed));
      FI3 := TMimLed( CreateDetail(  73, 20, '', TMimLed));
      FI4 := TMimLed( CreateDetail( 103, 20, '', TMimLed));
      FI5 := TMimLed( CreateDetail( 133, 20, '', TMimLed));
      FI6 := TMimLed( CreateDetail( 163, 20, '', TMimLed));
      FI7 := TMimLed( CreateDetail( 193, 20, '', TMimLed));
      FI8 := TMimLed( CreateDetail( 223, 20, '', TMimLed));

      FInp := TMimInput ( CreateDetail(   8, 80, 'Inp', TMimInput ));
      With TMimTextLabel( CreateDetail( 28, 81, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'in';
        AutoSize := False;
      End;

      FOutp := TMimOutput( CreateDetail( 219, 80, 'Outp', TMimOutput));
      With FOutp Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;
      FChain := TMimOutput( CreateDetail( 189, 80, 'Chain', TMimOutput));
      With FChain Do
      Begin
        Value := 0;
      End;

      With TMimTextLabel( CreateDetail( 155, 81, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'chain';
        AutoSize := False;
      End;

      With TMimTextLabel( CreateDetail( 57, 81, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text     := 'start';
        AutoSize := False;
      End;
      V := TMimViewer( CreateDetail( 107, 81, '', TMimViewer));
      V.Width := V.Width - 5;
      FSV  := TMimKnob( CreateDetail( 81, 78, '', TMimKnobMedium));
      With FSV Do
      Begin
        Viewer        := V;
        MinValue      := 0;
        MaxValue      := 512;
        Step          := 8;
        Value         := 0;
        FStartVal     := Value;
        OnValueChange := StartValChanged;
      End;

      FButMode := TMimPushButton( CreateDetail( 222, 2, '', TMimPushButton));
      With FButMode Do
      Begin
        Height        := 15;
        AllowAllUp    := True;
        OnValueChange := ButModeValueChanged;
        Down          := True;
      End;
      FViewMode := Ord( FButMode.Down);
    End;

//  Public

    Procedure   TMimTable.Execute; // Override;
    Var
      aValue : TMimValue;
    Begin
      aValue := FInp.Value;
      FChain.Value := FInp.Value;
      aValue := aValue - FStartVal + 1;
      If ( aValue > 0) And ( aValue < 9)
      Then FOutp.Value := FValues[ aValue]
      Else FOutp.Value := 0;
      FI1.Active := aValue = 1;
      FI2.Active := aValue = 2;
      FI3.Active := aValue = 3;
      FI4.Active := aValue = 4;
      FI5.Active := aValue = 5;
      FI6.Active := aValue = 6;
      FI7.Active := aValue = 7;
      FI8.Active := aValue = 8;
    End;


{ ========
  TNeuron = Class( TModule)
  Private
      FOut       : TOutput;
      FOutLearn  : TOutput;
      FIn1       : TInput;
      FIn2       : TInput;
      FIn3       : TInput;
      FIn4       : TInput;
      FIn5       : TInput;
      FIn6       : TInput;
      FIn7       : TInput;
      FIn8       : TInput;
      FIn9       : TInput;
      FIn10      : TInput;
      FInLearn   : TInput;
      FInd1      : TIndicator;
      FInd2      : TIndicator;
      FInd3      : TIndicator;
      Find4      : TIndicator;
      FInd5      : TIndicator;
      FInd6      : TIndicator;
      FInd7      : TIndicator;
      FInd8      : TIndicator;
      FInd9      : TIndicator;
      FInd10     : TIndicator;
      FIndLearn  : TIndicator;
      FIndOut    : TIndicator;
      FK1        : TKnob;
      FK2        : TKnob;
      FK3        : TKnob;
      FK4        : TKnob;
      FK5        : TKnob;
      FK6        : TKnob;
      FK7        : TKnob;
      FK8        : TKnob;
      FK9        : TKnob;
      FK10       : TKnob;
      FKnobParam : TKnob;
      FButtonAlg : TPushButton;
      FLabelAlg  : TTextLabel;
      FWeights   : Array[ 1 .. 10] Of Integer;
      FOldLearn  : Integer;
      FAlgorithm : Integer;
      FParam     : Integer;
  Published
    Property    K1             : Integer Read GetK1             Write SetK1;
    Property    K2             : Integer Read GetK2             Write SetK2;
    Property    K3             : Integer Read GetK3             Write SetK3;
    Property    K4             : Integer Read GetK4             Write SetK4;
    Property    K5             : Integer Read GetK5             Write SetK5;
    Property    K6             : Integer Read GetK6             Write SetK6;
    Property    K7             : Integer Read GetK7             Write SetK7;
    Property    K8             : Integer Read GetK8             Write SetK8;
    Property    K9             : Integer Read GetK9             Write SetK9;
    Property    K10            : Integer Read GetK10            Write SetK10;
    Property    Algorithm      : Integer Read FAlgorithm        Write SetAlgorithm;
    Property    KnobParamValue : Integer Read GetKnobParamValue Write SetKnobParamValue;
  Private
}

    Procedure   TMimNeuron.KValueChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FWeights[ (aSender As TMimKnob).Tag] := aValue;
    End;

    Procedure   TMimNeuron.KnobParamChanged( aSender: TObject; aValue: TMimValue);
    Begin
      FParam := aValue;
    End;

    Procedure   TMimNeuron.ButtonAlgClicked( aSender: TObject);
    Begin
      FButtonAlg.Down := False;
      Algorithm := ( Algorithm + 1) Mod 3;
    End;

    Function    TMimNeuron.GetK1 : TMimValue;
    Begin
      Result := FK1.Value;
    End;

    Procedure   TMimNeuron.SetK1 ( aValue: TMimValue);
    Begin
      FK1.Value := aValue;
    End;

    Function    TMimNeuron.GetK2 : TMimValue;
    Begin
      Result := FK2.Value;
    End;

    Procedure   TMimNeuron.SetK2 ( aValue: TMimValue);
    Begin
      FK2.Value := aValue;
    End;

    Function    TMimNeuron.GetK3 : TMimValue;
    Begin
      Result := FK3.Value;
    End;

    Procedure   TMimNeuron.SetK3 ( aValue: TMimValue);
    Begin
      FK3.Value := aValue;
    End;

    Function    TMimNeuron.GetK4 : TMimValue;
    Begin
      Result := FK4.Value;
    End;

    Procedure   TMimNeuron.SetK4 ( aValue: TMimValue);
    Begin
      FK4.Value := aValue;
    End;

    Function    TMimNeuron.GetK5 : TMimValue;
    Begin
      Result := FK5.Value;
    End;

    Procedure   TMimNeuron.SetK5 ( aValue: TMimValue);
    Begin
      FK5.Value := aValue;
    End;

    Function    TMimNeuron.GetK6 : TMimValue;
    Begin
      Result := FK6.Value;
    End;

    Procedure   TMimNeuron.SetK6 ( aValue: TMimValue);
    Begin
      FK6.Value := aValue;
    End;

    Function    TMimNeuron.GetK7 : TMimValue;
    Begin
      Result := FK7.Value;
    End;

    Procedure   TMimNeuron.SetK7 ( aValue: TMimValue);
    Begin
      FK7.Value := aValue;
    End;

    Function    TMimNeuron.GetK8 : TMimValue;
    Begin
      Result := FK8.Value;
    End;

    Procedure   TMimNeuron.SetK8 ( aValue: TMimValue);
    Begin
      FK8.Value := aValue;
    End;

    Function    TMimNeuron.GetK9 : TMimValue;
    Begin
      Result := FK9.Value;
    End;

    Procedure   TMimNeuron.SetK9 ( aValue: TMimValue);
    Begin
      FK9.Value := aValue;
    End;

    Function    TMimNeuron.GetK10: TMimValue;
    Begin
      Result := FK10.Value;
    End;

    Procedure   TMimNeuron.SetK10( aValue: TMimValue);
    Begin
      FK10.Value := aValue;
    End;

    Procedure   TMimNeuron.SetAlgorithm( aValue: Integer);
    Begin
      If FAlgorithm <> aValue
      Then Begin
        FAlgorithm := aValue;
        Case FAlgorithm Of
          0 : FLabelAlg.Text := 'mix';
          1 : FLabelAlg.Text := 'clip';
          2 : FLabelAlg.Text := 'neur';
        End;
      End;
    End;

    Function    TMimNeuron.GetKnobParamValue: TMimValue;
    Begin
      Result := FKnobParam.Value;
    End;

    Procedure   TMimNeuron.SetKnobParamValue( aValue: TMimValue);
    Begin
      FKnobParam.Value := aValue;
    End;

//  Protected

    Procedure   TMimNeuron.CreateDetails; // Override;

      Function InitialKnobValue: Integer;
      Begin
        Result := UnityValue - 2 * Random( UnityValue);
      End;

      Function InitKnob( aKnob: TMimKnob; aTag: Integer): TMimKnob;
      Begin
        Result := aKnob;
        With Result Do
        Begin
          Tag            := aTag;
          OnValueChange  := KValueChanged;
          MinValue       := - UnityValue;
          MaxValue       := UnityValue;
          Step           := UnityValue Div 250;
          Value          := InitialKnobValue;
          FWeights[ Tag] := Value;
        End;
      End;

    Begin
      Inherited CreateDetails;
      /////////////////////////////////////////////////////////////////////////
      Height := Height * 2;
      /////////////////////////////////////////////////////////////////////////
      FIn1       := TMimInput   ( CreateDetail(   8, 45, 'In1'     , TMimInput ));
      FIn2       := TMimInput   ( CreateDetail(  28, 45, 'In2'     , TMimInput ));
      FIn3       := TMimInput   ( CreateDetail(  48, 45, 'In3'     , TMimInput ));
      FIn4       := TMimInput   ( CreateDetail(  68, 45, 'In4'     , TMimInput ));
      FIn5       := TMimInput   ( CreateDetail(  88, 45, 'In5'     , TMimInput ));
      FIn6       := TMimInput   ( CreateDetail( 108, 45, 'In6'     , TMimInput ));
      FIn7       := TMimInput   ( CreateDetail( 128, 45, 'In7'     , TMimInput ));
      FIn8       := TMimInput   ( CreateDetail( 148, 45, 'In8'     , TMimInput ));
      FIn9       := TMimInput   ( CreateDetail( 168, 45, 'In9'     , TMimInput ));
      FIn10      := TMimInput   ( CreateDetail( 188, 45, 'In10'    , TMimInput ));
      FInLearn   := TMimInput   ( CreateDetail( 208, 45, 'InLearn' , TMimInput ));
      FOut       := TMimOutput  ( CreateDetail( 228, 45, 'Out'     , TMimOutput));
      FOutLearn  := TMimOutput  ( CreateDetail( 208, 80, 'OutLearn', TMimOutput));
      /////////////////////////////////////////////////////////////////////////
      Find1     := TMimLed( CreateDetail(  11, 20, '', TMimLed));
      Find2     := TMimLed( CreateDetail(  31, 20, '', TMimLed));
      FInd3     := TMimLed( CreateDetail(  51, 20, '', TMimLed));
      Find4     := TMimLed( CreateDetail(  71, 20, '', TMimLed));
      Find5     := TMimLed( CreateDetail(  91, 20, '', TMimLed));
      FInd6     := TMimLed( CreateDetail( 111, 20, '', TMimLed));
      FInd7     := TMimLed( CreateDetail( 131, 20, '', TMimLed));
      Find8     := TMimLed( CreateDetail( 151, 20, '', TMimLed));
      Find9     := TMimLed( CreateDetail( 171, 20, '', TMimLed));
      FInd10    := TMimLed( CreateDetail( 191, 20, '', TMimLed));
      FindLearn := TMimLed( CreateDetail( 211, 20, '', TMimLed));
      FindOut   := TMimLed( CreateDetail( 231, 20, '', TMimLed));
      /////////////////////////////////////////////////////////////////////////
      FOut      .ConnectorType := ctNeuron;
      FIn1      .ConnectorType := ctNeuron;
      FIn2      .ConnectorType := ctNeuron;
      FIn3      .ConnectorType := ctNeuron;
      FIn4      .ConnectorType := ctNeuron;
      FIn5      .ConnectorType := ctNeuron;
      FIn6      .ConnectorType := ctNeuron;
      FIn7      .ConnectorType := ctNeuron;
      FIn8      .ConnectorType := ctNeuron;
      FIn9      .ConnectorType := ctNeuron;
      FIn10     .ConnectorType := ctNeuron;
      FInLearn  .ConnectorType := ctNeuron;
      FOutLearn .ConnectorType := ctNeuron;
      /////////////////////////////////////////////////////////////////////////
      With TMimTextLabel( CreateDetail( 13, 27, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := '1';
        AutoSize := False;
      End;
      With TMimTextLabel( CreateDetail( 33, 27, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := '2';
        AutoSize := False;
      End;
      With TMimTextLabel( CreateDetail( 53, 27, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := '3';
        AutoSize := False;
      End;
      With TMimTextLabel( CreateDetail( 73, 27, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := '4';
        AutoSize := False;
      End;
      With TMimTextLabel( CreateDetail( 93, 27, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := '5';
        AutoSize := False;
      End;
      With TMimTextLabel( CreateDetail( 113, 27, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := '6';
        AutoSize := False;
      End;
      With TMimTextLabel( CreateDetail( 133, 27, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := '7';
        AutoSize := False;
      End;
      With TMimTextLabel( CreateDetail( 153, 27, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := '8';
        AutoSize := False;
      End;
      With TMimTextLabel( CreateDetail( 173, 27, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := '9';
        AutoSize := False;
      End;
      With TMimTextLabel( CreateDetail( 189, 27, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := '10';
        AutoSize := False;
      End;
      With TMimTextLabel( CreateDetail( 210, 27, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := 'ctr';
        AutoSize := False;
      End;
      With TMimTextLabel( CreateDetail( 228, 27, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := 'out';
        AutoSize := False;
      End;
      With TMimTextLabel( CreateDetail( 200, 64, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := 'ctr out';
        AutoSize := False;
      End;
      With TMimTextLabel( CreateDetail( 8, 64, '', TMimTextLabel)) Do
      Begin
        AutoSize := True;
        Text := 'weight controls';
        AutoSize := False;
      End;
      /////////////////////////////////////////////////////////////////////////
      FK1  := InitKnob( TMimKnob( CreateDetail(   7, 79, '', TMimKnobSmall)),  1);
      FK2  := InitKnob( TMimKnob( CreateDetail(  27, 79, '', TMimKnobSmall)),  2);
      FK3  := InitKnob( TMimKnob( CreateDetail(  47, 79, '', TMimKnobSmall)),  3);
      FK4  := InitKnob( TMimKnob( CreateDetail(  67, 79, '', TMimKnobSmall)),  4);
      FK5  := InitKnob( TMimKnob( CreateDetail(  87, 79, '', TMimKnobSmall)),  5);
      FK6  := InitKnob( TMimKnob( CreateDetail( 107, 79, '', TMimKnobSmall)),  6);
      FK7  := InitKnob( TMimKnob( CreateDetail( 127, 79, '', TMimKnobSmall)),  7);
      FK8  := InitKnob( TMimKnob( CreateDetail( 147, 79, '', TMimKnobSmall)),  8);
      FK9  := InitKnob( TMimKnob( CreateDetail( 167, 79, '', TMimKnobSmall)),  9);
      FK10 := InitKnob( TMimKnob( CreateDetail( 187, 79, '', TMimKnobSmall)), 10);
      //////////////////////////////////////////////////////////////////////////
      FKnobParam := TMimKnob( CreateDetail( 155, 62, '', TMimKnobSmall));
      With FKnobParam Do
      Begin
        OnValueChange := KnobParamChanged;
        MinValue      := 1;
        MaxValue      := UnityValue;
        Step          := UnityValue Div 250;
        Value         := UnityValue div 2;
        FParam        := UnityValue div 2;
      End;
      FLabelAlg := TMimTextLabel( CreateDetail( 100, 64, '', TMimTextLabel));
      With FLabelAlg Do
      Begin
        AutoSize  := true;
        Text      := 'neur';
        Algorithm := 2;
      End;
      //////////////////////////////////////////////////////////////////////////
      FButtonAlg := TMimPushButton( CreateDetail( 125, 62, '', TMimPushButton));
      With FButtonAlg Do
      Begin
        Height  := 15;
        OnClick := ButtonAlgClicked;
      End;
    End;

//   Public

    Procedure   TMimNeuron.Execute; // Override;

      Procedure RandomizeWeights( anAmount: TMimValue);
      Var
        aValue : TMimValue;
        i      : Integer;
      Begin
        For i := 1 To 10
        Do Begin
          aValue := FWeights[ i];
          If anAmount > 0
          Then Begin
            If aValue < 0
            Then aValue := aValue - Random( anAmount Div 100) + 5 - Random( 11)
            Else aValue := aValue + Random( anAmount Div 100) + 5 - Random( 11)
          End
          Else Begin
            If aValue < 0
            Then aValue := aValue + Random( - anAmount Div 100) + 5 - Random( 11)
            Else aValue := aValue - Random( - anAmount Div 100) + 5 - Random( 11);
          End;
          FWeights[ i] := aValue;
        End;
      End;

    Var
      V1   : TMimValue;
      V2   : TMimValue;
      V3   : TMimValue;
      V4   : TMimValue;
      V5   : TMimValue;
      V6   : TMimValue;
      V7   : TMimValue;
      V8   : TMimValue;
      V9   : TMimValue;
      V10  : TMimValue;
      VOut : TMimValue;
      VLrn : TMimValue;
      VVal : TMimValue;
    Begin
      V1   := FIn1. Value * FWeights[  1] Div 1000;
      V2   := FIn2. Value * FWeights[  2] Div 1000;
      V3   := FIn3. Value * FWeights[  3] Div 1000;
      V4   := FIn4. Value * FWeights[  4] Div 1000;
      V5   := FIn5. Value * FWeights[  5] Div 1000;
      V6   := FIn6. Value * FWeights[  6] Div 1000;
      V7   := FIn7. Value * FWeights[  7] Div 1000;
      V8   := FIn8. Value * FWeights[  8] Div 1000;
      V9   := FIn9. Value * FWeights[  9] Div 1000;
      V10  := FIn10.Value * FWeights[ 10] Div 1000;
      VVal := ( V1 + V2 + V3 + V4 + V5 + V6 + V7 + V8 + V9 + V10);
      Case Algorithm Of
        0 : VOut := VVal;
        1 :
          If VVal < - FParam
          Then VOut := - FParam
          Else If VVal > FParam
          Then VOut := FParam
          Else VOut := VVal;
        2 : VOut := Round( - 1000 + 2000 / ( 1 + Exp( - VVal / FParam)));
        Else Begin
          Vout      := VVal;
          Algorithm := 0;
        End;
      End;
      FOut.Value := VOut;

      FInd1.  Active := V1   > 0;
      FInd2.  Active := V2   > 0;
      FInd3.  Active := V3   > 0;
      FInd4.  Active := V4   > 0;
      FInd5.  Active := V5   > 0;
      FInd6.  Active := V6   > 0;
      FInd7.  Active := V7   > 0;
      FInd8.  Active := V8   > 0;
      FInd9.  Active := V9   > 0;
      FInd10. Active := V10  > 0;

      FIndOut.Active := VOut > 0;
      VLrn := FInLearn.Value;
      If FOldLearn <> VLrn
      Then Begin
        RandomizeWeights( VLrn);
        FOldLearn := VLrn;
      End;
      FOutLearn.Value := VLrn * VOut Div 1000;
    End;


{ ========
  TScope = Class( TModule)
  Private
      FInp         : TInput;
      FTrig        : TInp;
      FSens        : TKnob;
      FGraph       : TGraphSheet;
      FSensitivity : Integer;
      FDataPtr     : Integer;
      FRunning     : Boolean;
      FOldTrig     : Integer;
  Published
    Property    SenseValue: Integer Read GetSenseValue Write SetSenseValue;
  Private
}

    Procedure   TMimScope.SenseValueChanged( anObject: TObject; aValue: TMimValue);
    Begin
      FSensitivity := aValue;
    End;

    Function    TMimScope.GetSenseValue: TMimValue;
    Begin
      Result := FSens.Value;
    End;

    Procedure   TMimScope.SetSenseValue( aValue: TMimValue);
    Begin
      FSens.Value := aValue;
    End;

//  Protected

    Procedure   TMimScope.CreateDetails; // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;
      Height := Height * 4;

      FGraph := TMimGraphSheet( CreateDetail( 45, 25, '', TMimGraphSheet));
      With FGraph Do
      Begin
        Width    := Self.Width  - 60;
        Height   := Self.Height - 40;
        EltCount := Width;
        XScale   := 8000;
      End;

      FInp := TMimInput( CreateDetail( 9, 85, 'Inp', TMimInput ));
      With FInp Do
      Begin
        ConnectorType := ctSymmetric;
        Value         := 0;
      End;

      FTrig := TMimInput( CreateDetail( 9, 105, 'Trig', TMimInput ));
      With FTrig Do
      Begin
        ConnectorType := ctLogic;
        Value         := 0;
      End;

      V := TMimViewer( CreateDetail( 5, 25, '', TMimViewer));
      FSens := TMimKnob( CreateDetail( 8, 45, '', TMimKnob));
      With FSens Do
      Begin
        Viewer        := V;
        MinValue      := 0;
        MaxValue      := UnityValue * 10;
        Step          := UnityValue * 10 Div 250;
        Value         := UnityValue;
        OnValueChange := SenseValueChanged;
        FSensitivity  := Value;
      End;
      FOldTrig := 0;
    End;

//  Public

    Procedure   TMimScope.Execute; // Override;
    Var
      aValue : TMimValue;
    Begin
      aValue := FTrig.Value;
      With FGraph Do
      Begin
        If Not FRunning
        Then Begin
          FRunning := ( aValue > 0) And ( FOldTrig <= 0);
          If FRunning
          Then FDataPtr := 0;
        End;
        If FRunning
        Then Begin
          If ( FDataPtr < 0) Or ( FDataPtr > EltCount - 1)
          Then Begin
            FDataPtr := 0;
            FRunning := False;
          End;
          Data[ FDataPtr] := Point( FDataPtr, ( FSensitivity * FInp.Value) Div 1000);
          Inc( FDataPtr);
        End;
      End;
      FOldTrig := aValue;
    End;


{ ========
  TMorph = Class( TModule)
  Private
      FIn1_1       : TInput;
      FIn1_2       : TInput;
      FIn1_3       : TInput;
      FIn1_4       : TInput;
      FIn1_5       : TInput;
      FIn1_6       : TInput;
      FIn1_7       : TInput;
      FIn1_8       : TInput;
      FIn1_9       : TInput;
      FIn1_10      : TInput;
      FIn1_11      : TInput;
      FIn2_1       : TInput;
      FIn2_2       : TInput;
      FIn2_3       : TInput;
      FIn2_4       : TInput;
      FIn2_5       : TInput;
      FIn2_6       : TInput;
      FIn2_7       : TInput;
      FIn2_8       : TInput;
      FIn2_9       : TInput;
      FIn2_10      : TInput;
      FIn2_11      : TInput;
      FInSelect    : TInput;
      FOut_1       : TOutput;
      FOut_2       : TOutput;
      FOut_3       : TOutput;
      FOut_4       : TOutput;
      FOut_5       : TOutput;
      FOut_6       : TOutput;
      FOut_7       : TOutput;
      FOut_8       : TOutput;
      FOut_9       : TOutput;
      FOut_10      : TOutput;
      FOut_11      : TOutput;
  Protected
}

    Procedure   TMimMorph.CreateDetails; // Override;
    Var
      i    : Integer;
    Begin
      Inherited CreateDetails;
      Height := Height * 2;
      FIn1_1    := TMimInput ( CreateDetail(    8, 23, 'In1_1'   , TMimInput ));
      FIn1_2    := TMimInput ( CreateDetail(   28, 23, 'In1_2'   , TMimInput ));
      FIn1_3    := TMimInput ( CreateDetail(   48, 23, 'In1_3'   , TMimInput ));
      FIn1_4    := TMimInput ( CreateDetail(   68, 23, 'In1_4'   , TMimInput ));
      FIn1_5    := TMimInput ( CreateDetail(   88, 23, 'In1_5'   , TMimInput ));
      FIn1_6    := TMimInput ( CreateDetail(  108, 23, 'In1_6'   , TMimInput ));
      FIn1_7    := TMimInput ( CreateDetail(  128, 23, 'In1_7'   , TMimInput ));
      FIn1_8    := TMimInput ( CreateDetail(  148, 23, 'In1_8'   , TMimInput ));
      FIn1_9    := TMimInput ( CreateDetail(  168, 23, 'In1_9'   , TMimInput ));
      FIn1_10   := TMimInput ( CreateDetail(  188, 23, 'In1_10'  , TMimInput ));
      FIn1_11   := TMimInput ( CreateDetail(  208, 23, 'In1_11'  , TMimInput ));
      FIn2_1    := TMimInput ( CreateDetail(    8, 48, 'In2_1'   , TMimInput ));
      FIn2_2    := TMimInput ( CreateDetail(   28, 48, 'In2_2'   , TMimInput ));
      FIn2_3    := TMimInput ( CreateDetail(   48, 48, 'In2_3'   , TMimInput ));
      FIn2_4    := TMimInput ( CreateDetail(   68, 48, 'In2_4'   , TMimInput ));
      FIn2_5    := TMimInput ( CreateDetail(   88, 48, 'In2_5'   , TMimInput ));
      FIn2_6    := TMimInput ( CreateDetail(  108, 48, 'In2_6'   , TMimInput ));
      FIn2_7    := TMimInput ( CreateDetail(  128, 48, 'In2_7'   , TMimInput ));
      FIn2_8    := TMimInput ( CreateDetail(  148, 48, 'In2_8'   , TMimInput ));
      FIn2_9    := TMimInput ( CreateDetail(  168, 48, 'In2_9'   , TMimInput ));
      FIn2_10   := TMimInput ( CreateDetail(  188, 48, 'In2_10'  , TMimInput ));
      FIn2_11   := TMimInput ( CreateDetail(  208, 48, 'In2_11'  , TMimInput ));
      FInSelect := TMimInput ( CreateDetail(  228, 48, 'InSelect', TMimInput ));
      FOut_1    := TMimOutput( CreateDetail(    8, 73, 'Out_1'   , TMimOutput));
      FOut_2    := TMimOutput( CreateDetail(   28, 73, 'Out_2'   , TMimOutput));
      FOut_3    := TMimOutput( CreateDetail(   48, 73, 'Out_3'   , TMimOutput));
      FOut_4    := TMimOutput( CreateDetail(   68, 73, 'Out_4'   , TMimOutput));
      FOut_5    := TMimOutput( CreateDetail(   88, 73, 'Out_5'   , TMimOutput));
      FOut_6    := TMimOutput( CreateDetail(  108, 73, 'Out_6'   , TMimOutput));
      FOut_7    := TMimOutput( CreateDetail(  128, 73, 'Out_7'   , TMimOutput));
      FOut_8    := TMimOutput( CreateDetail(  148, 73, 'Out_8'   , TMimOutput));
      FOut_9    := TMimOutput( CreateDetail(  168, 73, 'Out_9'   , TMimOutput));
      FOut_10   := TMimOutput( CreateDetail(  188, 73, 'Out_10'  , TMimOutput));
      FOut_11   := TMimOutput( CreateDetail(  208, 73, 'Out_11'  , TMimOutput));
      For i := 0 To ComponentCount - 1 Do
        If Components[ i] Is TMimConnector
        Then With TMimConnector( Components[ i]) Do
          Begin
            ConnectorType := ctSymmetric;
            Value         := 0;
          End;
    End;

//  Public

    Procedure   TMimMorph.Execute; // Override;
    Var
      V1 : Double;
      V2 : Double;
    Begin
      If FInSelect.Connected
      Then V1 := FInSelect.Value / 2000.0 + 0.5
      Else V1 := 0.5;
      V2 := 1.0 - V1;
      FOut_1.Value  := Round( FIn1_1 .Value  * V1 + FIn2_1 .Value  * V2);
      FOut_2.Value  := Round( FIn1_2 .Value  * V1 + FIn2_2 .Value  * V2);
      FOut_3.Value  := Round( FIn1_3 .Value  * V1 + FIn2_3 .Value  * V2);
      FOut_4.Value  := Round( FIn1_4 .Value  * V1 + FIn2_4 .Value  * V2);
      FOut_5.Value  := Round( FIn1_5 .Value  * V1 + FIn2_5 .Value  * V2);
      FOut_6.Value  := Round( FIn1_6 .Value  * V1 + FIn2_6 .Value  * V2);
      FOut_7.Value  := Round( FIn1_7 .Value  * V1 + FIn2_7 .Value  * V2);
      FOut_8.Value  := Round( FIn1_8 .Value  * V1 + FIn2_8 .Value  * V2);
      FOut_9.Value  := Round( FIn1_9 .Value  * V1 + FIn2_9 .Value  * V2);
      FOut_10.Value := Round( FIn1_10.Value  * V1 + FIn2_10.Value  * V2);
      FOut_11.Value := Round( FIn1_11.Value  * V1 + FIn2_11.Value  * V2);
    End;

{
  TSlotCtrl = Class( TCustomModule)
  Private
      FButtonStart : TPushButton;
      FButtonStop  : TPushButton;
      FActive      : Boolean;
  Published
    Property    Active : Boolean Read FActive Write SetActive;
  Private
}

    Procedure   TMimSlotCtrl.ButtonPress( aSender: TObject; aValue: Boolean);
    Begin
      If aValue
      Then
        If aSender = FButtonStart
        Then Active := True
        Else Active := False; 
    End;

    Procedure   TMimSlotCtrl.SetActive( aValue: Boolean);
    Begin
      If aValue <> FActive
      Then Begin
        FActive := aValue;
        If FActive
        Then FButtonStart.Down := True
        Else FButtonStop .Down := True;
        If Owner Is TMimDrawSheet
        Then TMimDrawSheet( Owner).SlotActive := FActive;
      End;
    End;

//  Protected

    Procedure   TMimSlotCtrl.CreateDetails; // Oveeride;
    Begin
      Inherited CreateDetails;
      FButtonStop := TMimPushButton( CreateDetail( 50, 20, '', TMimPushButton));
      With FButtonStop Do
      Begin
        LoadBitmap( 'Stop.bmp');
        Down       := False;
        AllowAllUp := False;
        GroupId    := 1;
        OnValueChange := ButtonPress;
      End;
      FButtonStart := TMimPushButton( CreateDetail( 80, 20, '', TMimPushButton));
      With FButtonStart Do
      Begin
        LoadBitmap( 'Start.bmp');
        Down       := True;
        AllowAllUp := False;
        GroupId    := 1;
        OnValueChange := ButtonPress;
      End;
      Active := True;
    End;

{ ========
  TShifter = Class( TCustomModule)
  Private
      FIn          : TInput;
      FOut_1       : TOutput;
      FOut_2       : TOutput;
      FOut_3       : TOutput;
      FOut_4       : TOutput;
      FOut_5       : TOutput;
      FOut_6       : TOutput;
      FOut_7       : TOutput;
      FOut_8       : TOutput;
      FOut_9       : TOutput;
      FOut_10      : TOutput;
      FKnobDelay   : TKnob;
      FDelayValue  : Integer;
      FCount       : Integer;
  Published
    Property    DelayValue: Integer Read FDelayValue Write SetDelayValue;
  Private
}

    Procedure   TMimShifter.DelayValueChanged( anObject: TObject; aValue: TMimValue);
    Begin
      FDelayValue := aValue;
    End;

    Function    TMimShifter.GetDelayValue: TMimValue;
    Begin
      Result := FDelayValue;
    End;

    Procedure   TMimShifter.SetDelayValue( aValue: TMimValue);
    Begin
      FKnobDelay.Value := aValue;
    End;

//  Protected

    Procedure   TMimShifter.CreateDetails; // Override;
    Var
      V : TMimViewer;
    Begin
      Inherited CreateDetails;

      FIn     := TMimInput ( CreateDetail( 188,  5, 'In'   , TMimInput));
      FOut_1  := TMimOutput( CreateDetail(   8, 30, 'Out1' , TMimOutput));
      FOut_2  := TMimOutput( CreateDetail(  28, 30, 'Out2' , TMimOutput));
      FOut_3  := TMimOutput( CreateDetail(  48, 30, 'Out3' , TMimOutput));
      FOut_4  := TMimOutput( CreateDetail(  68, 30, 'Out4' , TMimOutput));
      FOut_5  := TMimOutput( CreateDetail(  88, 30, 'Out5' , TMimOutput));
      FOut_6  := TMimOutput( CreateDetail( 108, 30, 'Out6' , TMimOutput));
      FOut_7  := TMimOutput( CreateDetail( 128, 30, 'Out7' , TMimOutput));
      FOut_8  := TMimOutput( CreateDetail( 148, 30, 'Out8' , TMimOutput));
      FOut_9  := TMimOutput( CreateDetail( 168, 30, 'Out9' , TMimOutput));
      FOut_10 := TMimOutput( CreateDetail( 188, 30, 'Out10', TMimOutput));

      V          := TMimViewer( CreateDetail( 208, 2, '', TMimViewer));
      FKnobDelay := TMimKnob( CreateDetail( 208, 18, '', TMimKnob));
      With FKnobDelay Do
      Begin
        Viewer        := V;
        MinValue      := 1;
        MaxValue      := 256;
        Step          := 1;
        Value         := 1;
        OnValueChange := DelayValueChanged;
        FDelayValue   := Value;
      End;
    End;

//  Public

    Procedure   TMimShifter.Execute; // Override;
    Begin
      Inc( FCount);
      If FCount > FDelayValue
      Then FCount := 0;
      If FCount = 0
      Then Begin
        FOut_10.Value := FOut_9.Value;
        FOut_9 .Value := FOut_8.Value;
        FOut_8 .Value := FOut_7.Value;
        FOut_7 .Value := FOut_6.Value;
        FOut_6 .Value := FOut_5.Value;
        FOut_5 .Value := FOut_4.Value;
        FOut_4 .Value := FOut_3.Value;
        FOut_3 .Value := FOut_2.Value;
        FOut_2 .Value := FOut_1.Value;
        FOut_1 .Value := FIn   .Value;
      End;
    End;



////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


Initialization

  RegisterClasses(
    [
      TMimConstant,
      TMimAmplifier,
      TMimMultiplier,
      TMimDivider,
      TMimSquare,
      TMimSine,
      TMimSaw,
      TMimRandom,
      TMimRndPulse,
      TMimClSquare,
      TMimClSine,
      TMimClSaw,
      TMimClRandom,
      TMimClRndPulse,
      TMimMidiIn,
      TMimMidiOut,
      TMimControlIn,
      TMimControlOut,
      TMimBendIn,
      TMimBendOut,
      TMimDividerFixed,
      TMimFreqDivider,
      TMimTable,
      TMimNeuron,
      TMimScope,
      TMimMorph,
      TMimSlotCtrl,
      TMimShifter
    ]
  );

Finalization

  UnregisterClasses(
    [
      TMimConstant,
      TMimAmplifier,
      TMimMultiplier,
      TMimDivider,
      TMimSquare,
      TMimSine,
      TMimSaw,
      TMimRandom,
      TMimRndPulse,
      TMimClSquare,
      TMimClSine,
      TMimClSaw,
      TMimClRandom,
      TMimClRndPulse,
      TMimMidiIn,
      TMimMidiOut,
      TMimControlIn,
      TMimControlOut,
      TMimBendIn,
      TMimBendOut,
      TMimDividerFixed,
      TMimFreqDivider,
      TMimTable,
      TMimNeuron,
      TMimScope,
      TMimMorph,
      TMimSlotCtrl,
      TMimShifter
    ]
  );

End.
